// Created by John Liaperdos - August 16, 2015
// Modified: September 11, 2015  

// preload images
	var bookmark_Image=new Image();
    bookmark_Image.src="../images/misc/bookmark.png";
	var bullet_Image=new Image();
    bullet_Image.src="../images/misc/bullet.png";
	
var originalBookmarksListContent;
var bookmarkOperationInProgress=false;
var bookmarkInitializationInterval;

function initializeBookmarks() {
	if(checkIfSettingEnabled(2)) //bookmarks are enabled, or default settings apply
	{		
		if(typeof(Storage) == "undefined" && !checkIfSettingEnabled(8)) {return};
		if(!checkIfSettingEnabled(8)) //bookmarks saved in LocalStorage
		{
			showBookmarksInChapters();
			var sectionClassArray=['section','subsection','subsubsection'];
			var i;
			for(i=0;i<sectionClassArray.length;i++)
			{
				setSectionTitleBehavior(sectionClassArray[i]);
			};
		}
		else //bookmarks saved in Google Drive
		{
			//wait until highlight initialization has finished
				bookmarkInitializationInterval=setInterval(
					function(){
						if(textHighlightInitializationPending==true){return};
						clearInterval(bookmarkInitializationInterval);
						showBookmarksInChapters();
					}
				,2000);					
		};
	};
};

function formatSectionTitle(title_string){
	title_text=title_string.substring(title_string.indexOf(' ')+1);
	title_number=title_string.substr(0,title_string.indexOf(' ')+1);
	return {title:title_text,number:title_number};
}

function setSectionTitleBehavior(section_classname){
	var BookmarkChapterTitlesArray=['Εισαγωγικές Γνώσεις', 'Επαφή p-n, Δίοδοι', 'Διπολικά τρανζίστορ', 'Τρανζίστορ επίδρασης πεδίου – MOSFET', 'Ψηφιακά λογικά κυκλώματα ', 'Ενισχυτές', 'Φίλτρα', 'Ταλαντωτές']
	var section_elements=document.getElementsByClassName(section_classname);
	var i;
	var thisChapterNumber=document.getElementsByClassName("chapter_number")[0].innerHTML;
	for(i=0;i<section_elements.length;i++)
	{
		if(section_elements[i].innerHTML.indexOf('bookmark.png')==-1) // adding bookmark
		{
			section_elements[i].title="Προσθήκη σελιδοδείκτη";
			section_elements[i].style.cursor='url(../images/misc/add_bookmark_cursor.cur), url(../images/misc/add_bookmark_cursor.png), pointer'; 
		}
		else
		{
			section_elements[i].title="Αφαίρεση σελιδοδείκτη";
			section_elements[i].style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer'; 
		};		
		section_elements[i].onclick=function(){
			if(this.querySelector('span.reader_highlights') || bookmarkOperationInProgress)
			{
				return;
			};
			var content_string;
			if(this.innerHTML.indexOf('bookmark.png')==-1) // adding bookmark
			{				
				content_string='<tr id="bookmark_'+this.id+'"><td><img width="15" src="'+bullet_Image.src+'" style="display:inline-block; vertical-align:middle;" alt=""/></td><td><a href="chapter_0'+thisChapterNumber+'.xhtml"><i>Κεφ. '+thisChapterNumber+': &#8220;'+BookmarkChapterTitlesArray[thisChapterNumber-1]+'&#8221;</i> </a></td><td><i>&#167; '+formatSectionTitle(this.innerHTML).number+'</i></td><td><a href="chapter_0'+thisChapterNumber+'.xhtml#'+this.id+'"> <b style="white-space:pre-wrap;">'+formatSectionTitle(this.innerHTML).title+'</b></a></td><td><button style="margin-left:15px;" onclick="deleteBookmarkEntry(\''+this.id+'\');">Διαγραφή</button></td></tr>';
				
				if(!checkIfSettingEnabled(8)) //bookmarks saved in LocalStorage
				{
					bookmarkOperationInProgress=true;
					var thisVar=this;
					thisVar.style.cursor="wait";
					var stored_content=localStorageGetDeCompress('intro_to_electronics_bookmarks');
					if(stored_content===null || stored_content=='null'){stored_content=''};
					localStorageSetCompress('intro_to_electronics_bookmarks',stored_content+content_string);
					thisVar.innerHTML=thisVar.innerHTML+"<img class='inChapterBookmarkIMG' width='20' src='"+bookmark_Image.src+"' alt='' style='display:inline-block;vertical-align:middle; margin-left:10px;'/>";
					thisVar.title="Αφαίρεση σελιδοδείκτη";
					thisVar.style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer'; 
					bookmarkOperationInProgress=false;
				}
				else //bookmarks saved in Google Drive
				{
					var thisVar=this;
					bookmarkOperationInProgress=true;
					var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
					if(google_script_URL==''){bookmarkOperationInProgress=false; return;};
					thisVar.style.cursor="wait";
					$.post(google_script_URL, {mode: "getValue", cellID: "A1"}, 
						function(data, status){
							if(status!="success") {bookmarkOperationInProgress=false; thisVar.style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer';  return;};
							var stored_content=LZString.decompressFromUTF16(data);
							if(stored_content===null || stored_content=='null'){stored_content=''};
							var googleScriptURL=getCookie("intro_to_electronics_google_script_URL");
							if(googleScriptURL==''){bookmarkOperationInProgress=false; thisVar.style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer';  return;};
							$.post(googleScriptURL, {cellID: "A1", cellContent: LZString.compressToUTF16(stored_content+content_string), mode: "setValue"},
								function(data, status){
									if(status!="success"){bookmarkOperationInProgress=false; thisVar.style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer';  return;};
									thisVar.innerHTML=thisVar.innerHTML+"<img class='inChapterBookmarkIMG' width='20' src='"+bookmark_Image.src+"' alt='' style='display:inline-block;vertical-align:middle; margin-left:10px;'/>";
									thisVar.title="Αφαίρεση σελιδοδείκτη";
									thisVar.style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer'; 
									bookmarkOperationInProgress=false;
								}
							);								
						}						
					);
				};
			}
			else //removing bookmark
			{ 
				var j;
				for (j=0;j<this.children.length;j++) 
				{
					this.removeChild(this.children[j]);
				};
				deleteBookmarkEntry(this.id);
				this.title="Προσθήκη σελιδοδείκτη";
				this.style.cursor='url(../images/misc/add_bookmark_cursor.cur), url(../images/misc/add_bookmark_cursor.png), pointer';
			};			
		};
	};	
}

function showBookmarksInChaptersMain(stored_bookmarks){
	var dummyTableElement = document.createElement("tbody");
	dummyTableElement.innerHTML=stored_bookmarks;
	dummyTableRowElements=dummyTableElement.children;
	var i
	for(i=0;i<dummyTableRowElements.length;i++)
	{
		var target_section_id=dummyTableRowElements[i].id.substring(9);
		var target_section_element=document.getElementById(target_section_id);
		if(target_section_element!==null)
		{
			// remove bookmark 'img' children if exist
				var j;
				for (j=0;j<target_section_element.children.length;j++) 
				{
					target_section_element.removeChild(target_section_element.children[j]);
				};
			// add bookmark image 'img' node
				target_section_element.style.cursor='url(../images/misc/remove_bookmark_cursor.cur), url(../images/misc/remove_bookmark_cursor.png), pointer';
				target_section_element.title="Αφαίρεση σελιδοδείκτη";
				target_section_element.innerHTML=target_section_element.innerHTML+"<img class='inChapterBookmarkIMG' width='20' src='"+bookmark_Image.src+"' alt='' style='display:inline-block;vertical-align:middle; margin-left:10px;'/>";		
				target_section_element.onclick=
					function(){
						var j;
						for (j=0;j<this.children.length;j++) 
						{
							this.removeChild(this.children[j]);
						};
						deleteBookmarkEntry(this.id);
						this.title="Προσθήκη σελιδοδείκτη";
						this.style.cursor='url(../images/misc/add_bookmark_cursor.cur), url(../images/misc/add_bookmark_cursor.png), pointer';
					};				
		};	
	};
	if(checkIfSettingEnabled(8)) //bookmarks saved in Google Drive
	{
		var sectionClassArray=['section','subsection','subsubsection'];
		var i;
		for(i=0;i<sectionClassArray.length;i++)
		{
			setSectionTitleBehavior(sectionClassArray[i]);
		};
	};
}

function showBookmarksInChapters(){
	if(!checkIfSettingEnabled(8)) //bookmarks saved in LocalStorage
	{
		var stored_bookmarks=localStorageGetDeCompress('intro_to_electronics_bookmarks');
		if(stored_bookmarks===null || stored_bookmarks=='' || stored_bookmarks=='null'){return};
		showBookmarksInChaptersMain(stored_bookmarks);	
	}
	else //bookmarks saved in Google Drive
	{
		var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
		if(google_script_URL==''){return};
		$.post(google_script_URL, {mode: "getValue", cellID: "A1"}, 
			function(data, status){
				if(status!="success") {return};
				var stored_bookmarks=LZString.decompressFromUTF16(data);
				showBookmarksInChaptersMain(stored_bookmarks);				
			}						
		);		
	};
}

var confirmed_bookmark_deletion=false;
var waitConfirmationInterval;

function confirmBookmarkDeletion(decision){
	document.getElementById("deleteBookmarkConfirmation").style.display='none'; // hide confirmation dialog
	confirmed_bookmark_deletion=decision;
}

function deleteBookmarkEntry(section_id){
	if(document.getElementById("bookmark_list")) // confirm deletion if called from bookmarks page
	{
		confirmed_bookmark_deletion=false;
		document.getElementById('bookmarkDeletionConfirmationMessage').innerHTML='Διαγραφή σελιδοδείκτη;'; // edit confirmation message
		// disable global bookmark deletion button
			$('#deleteAllBookmarksButton').prop("disabled", true); 
		// disable individual bookmark deletion buttons
			$('#bookmark_list').find('button').prop("disabled", true);
		document.getElementById("deleteBookmarkConfirmation").style.display='block'; // show confirmation dialog		
		waitConfirmationInterval=setInterval(function(){deleteBookmarkEntryConfirmed(section_id)},400);	
	}
	else
	{
		deleteBookmarkEntryConfirmed(section_id);
	};
}

function deleteBookmarkEntryConfirmed(bookmarked_section_id){
	if(document.getElementById("bookmark_list")) // called from bookmarks page
	{
		if(document.getElementById("deleteBookmarkConfirmation").style.display=='block') // user decision pending
		{
			return;
		};
		clearInterval(waitConfirmationInterval); //stop waiting
		//user aborts deletion
			if(confirmed_bookmark_deletion==false)
			{
				// re-enable all other bookmark deletion buttons
					$('#bookmark_list').find('button').prop("disabled", false);
				// re-enable global bookmark deletion button
					$('#deleteAllBookmarksButton').prop("disabled", false); 					
				return;
			}; 
		confirmed_bookmark_deletion=false; //reset decision variable
	};
	if(!checkIfSettingEnabled(8)) //bookmarks saved in LocalStorage
	{
		var stored_bookmarks=localStorageGetDeCompress('intro_to_electronics_bookmarks');
		if(stored_bookmarks===null || stored_bookmarks=='' || stored_bookmarks=='null'){return};
		var dummyTableElement = document.createElement("tbody");
		dummyTableElement.innerHTML=stored_bookmarks;
		if(dummyTableElement.querySelector('#bookmark_'+bookmarked_section_id)!==null)
		{
			dummyTableElement.removeChild(dummyTableElement.querySelector('#bookmark_'+bookmarked_section_id));
			localStorageSetCompress('intro_to_electronics_bookmarks',dummyTableElement.innerHTML);
			if(document.getElementById("bookmark_list")) // called from bookmarks page
			{	
				fillBookmarkTable();
				// re-enable all other bookmark deletion buttons
					$('#bookmark_list').find('button').prop("disabled", false);
				// re-enable global bookmark deletion button
					$('#deleteAllBookmarksButton').prop("disabled", false); 
			};
		};		
	}
	else //bookmarks saved in Google Drive
	{
		var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
		if(google_script_URL==''){return};
		$.post(google_script_URL, {mode: "getValue", cellID: "A1"}, 
			function(data, status){
				if(status!="success") {return};
				var stored_bookmarks=LZString.decompressFromUTF16(data);
				if(stored_bookmarks===null || stored_bookmarks=='' || stored_bookmarks=='null'){return};
				var dummyTableElement = document.createElement("tbody");
				dummyTableElement.innerHTML=stored_bookmarks;
				if(dummyTableElement.querySelector('#bookmark_'+bookmarked_section_id)!==null)
				{
					dummyTableElement.removeChild(dummyTableElement.querySelector('#bookmark_'+bookmarked_section_id));
					var googleScriptURL=getCookie("intro_to_electronics_google_script_URL");
					if(googleScriptURL==''){return};
					$.post(googleScriptURL, {cellID: "A1", cellContent: LZString.compressToUTF16(dummyTableElement.innerHTML), mode: "setValue"},
						function(data, status){
							if(status!="success"){return};
							if(document.getElementById("bookmark_list")) // called from bookmarks page
							{	
								fillBookmarkTable();
								// re-enable all other bookmark deletion buttons
									$('#bookmark_list').find('button').prop("disabled", false);
								// re-enable global bookmark deletion button
									$('#deleteAllBookmarksButton').prop("disabled", false); 
							};							
						}
					);	
				};	
			}						
		);					
	};
} 	

function fillBookmarkTable(){
	var message_div_element=document.getElementById("message_div");
	var bookmark_list_element=document.getElementById("bookmark_list");
	document.getElementById('deleteAllBookmarksButton').style.display="none";
	message_div_element.innerHTML="Φόρτωση σελιδοδεικτών ...";
	originalBookmarksListContent=bookmark_list_element.innerHTML;
	if(typeof(Storage) == "undefined" && !checkIfSettingEnabled(8)) 
	{
		message_div_element.innerHTML="<i>Ο φυλλομετρητής σας δεν υποστηρίζει τον ορισμό σελιδοδεικτών.</i>";
	}
	else
	{
		if(!checkIfSettingEnabled(8)) //bookmarks saved in LocalStorage
		{
			var bookmarks_list_content=localStorageGetDeCompress('intro_to_electronics_bookmarks');
			if(bookmarks_list_content!='' && bookmarks_list_content!==null && bookmarks_list_content!=='null')
			{
				var message_div_content='Ταξινόμηση: <br/><a id="ascending_link" style="margin-right:20px;" href="#" onclick="sortBookmarksAscDescending(\'ascending\'); return false;">Αύξουσα αριθμητική</a> <a id="descending_link" style="margin-right:20px;" href="#" onclick="sortBookmarksAscDescending(\'descending\'); return false;">Φθίνουσα αριθμητική</a><a id="chronological_link" style="margin-right:20px; background:#C2D1FF;" href="#" onclick="sortBookmarksByEntry(); return false;">Κατά σειρά καταχώρισης</a><hr/>';
				message_div_element.innerHTML=message_div_content;
				$("#bookmark_list").html(bookmarks_list_content);
				originalBookmarksListContent=bookmark_list_element.innerHTML;
				document.getElementById('deleteAllBookmarksButton').style.display="block"; // show delete all" button
			}
			else
			{
				message_div_element.innerHTML="<i>Δεν έχουν ορισθεί σελιδοδείκτες.</i>";
				bookmark_list_element.innerHTML='';
			};
		}
		else //bookmarks saved in Google Drive
		{
			var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
			if(google_script_URL==''){return;};
			$.post(google_script_URL, {mode: "getValue", cellID: "A1"}, 
				function(data, status){
					if(status!="success") {return};
					var bookmarks_list_content=LZString.decompressFromUTF16(data);
					if(bookmarks_list_content!='' && bookmarks_list_content!==null && bookmarks_list_content!=='null')
					{
						var message_div_content='Ταξινόμηση: <br/><a id="ascending_link" style="margin-right:20px;" href="#" onclick="sortBookmarksAscDescending(\'ascending\'); return false;">Αύξουσα αριθμητική</a> <a id="descending_link" style="margin-right:20px;" href="#" onclick="sortBookmarksAscDescending(\'descending\'); return false;">Φθίνουσα αριθμητική</a><a id="chronological_link" style="margin-right:20px; background:#C2D1FF;" href="#" onclick="sortBookmarksByEntry(); return false;">Κατά σειρά καταχώρισης</a><hr/>';
						message_div_element.innerHTML=message_div_content;
						$("#bookmark_list").html(bookmarks_list_content);
						originalBookmarksListContent=bookmark_list_element.innerHTML;
						document.getElementById('deleteAllBookmarksButton').style.display="block"; // show delete all" button
					}
					else
					{
						message_div_element.innerHTML="<i>Δεν έχουν ορισθεί σελιδοδείκτες.</i>";
						bookmark_list_element.innerHTML='';
					};
				}						
			);							
		};
	};
}

function deleteAllBookmarks(){
	confirmed_bookmark_deletion=false;
	// disable individual bookmark deletion buttons
		$('#bookmark_list').find('button').prop("disabled", true);
	// disable global bookmark deletion button
		$('#deleteAllBookmarksButton').prop("disabled", true); 
	// show confirmation dialog, if another one is not already pending
		if(document.getElementById("deleteBookmarkConfirmation").style.display!='none'){return};
	// edit confirmation message
		document.getElementById('bookmarkDeletionConfirmationMessage').innerHTML='Διαγραφή <b>όλων</b> των σελιδοδεικτών;'; 
	document.getElementById("deleteBookmarkConfirmation").style.display='block'; // show confirmation dialog		
	waitConfirmationInterval=setInterval(function(){deleteAllBookmarksConfirmed()},400);	
}

function deleteAllBookmarksConfirmed(){
	if(document.getElementById("deleteBookmarkConfirmation").style.display=='block') // user decision pending
	{
		return;
	};
	clearInterval(waitConfirmationInterval); //stop waiting
	//user aborts deletion
		if(confirmed_bookmark_deletion==false)
		{
			$('#bookmark_list').find('button').prop("disabled", false); // re-enable individual bookmark deletion buttons
			$('#deleteAllBookmarksButton').prop("disabled", false); // re-enable global bookmark deletion button
			return;
		}; 
	confirmed_bookmark_deletion=false; //reset decision variable
	// delete all bookmarks from storage
		if(!checkIfSettingEnabled(8)) //bookmarks saved in LocalStorage
		{	
			localStorage.removeItem('intro_to_electronics_bookmarks');
		}
		else //bookmarks saved in Google Drive
		{
			var googleScriptURL=getCookie("intro_to_electronics_google_script_URL");
			if(googleScriptURL==''){return};
			$.post(googleScriptURL, {cellID: "A1", cellContent: "", mode: "setValue"});			
		};
	// update screen
		var message_div_element=document.getElementById("message_div");
		var bookmark_list_element=document.getElementById("bookmark_list");
		message_div_element.innerHTML="<i>Δεν έχουν ορισθεί σελιδοδείκτες.</i>";
		bookmark_list_element.innerHTML='';
		$('#bookmark_list').find('button').prop("disabled", false); // re-enable individual bookmark deletion buttons
		$('#deleteAllBookmarksButton').css("display", 'none'); // hide global bookmark deletion button		
}

function sortBookmarksAscDescending(order_string){	
	var bookmark_list_element=document.getElementById("bookmark_list");
	var bookmarksStructure=bookmark_list_element.querySelectorAll('tr');
	var bookmarkIdsArray=[];
	var i;
	for(i=0;i<bookmarksStructure.length;i++)
	{
		bookmarkIdsArray[i]=bookmarksStructure[i].id;
	};
	var bookmarkIdsArrayOriginal=[];	
	var bookmarkIdsArraySorted=bookmarkIdsArray.concat().sort();	
	var sortedBookmarkIndices=[];
	for(i=0;i<bookmarkIdsArraySorted.length;i++)
	{
		sortedBookmarkIndices[i]=bookmarkIdsArray.indexOf(bookmarkIdsArraySorted[i]);
		
	};
	var sortedBookmarksStructure=[];
	for(i=0;i<bookmarksStructure.length;i++)
	{
		sortedBookmarksStructure[i]=bookmarksStructure[sortedBookmarkIndices[i]];
	};
	var newContentString='';
	if(order_string=='ascending')
	{
		document.getElementById("ascending_link").style.background="#C2D1FF";
		document.getElementById("descending_link").style.background="";
		document.getElementById("chronological_link").style.background="";
		for(i=0;i<sortedBookmarksStructure.length;i++)
		{
			newContentString=newContentString+'<tr id="'+sortedBookmarksStructure[i].id+'">'+sortedBookmarksStructure[i].innerHTML+'</tr>';
		};			
	}
	else
	{
		document.getElementById("ascending_link").style.background="";
		document.getElementById("descending_link").style.background="#C2D1FF";
		document.getElementById("chronological_link").style.background="";
		for(i=sortedBookmarksStructure.length-1;i>=0;i--)
		{
			newContentString=newContentString+'<tr id="'+sortedBookmarksStructure[i].id+'">'+sortedBookmarksStructure[i].innerHTML+'</tr>';
		};			
	}
	document.getElementById("bookmark_list").innerHTML=newContentString;
}

function sortBookmarksByEntry(){
	document.getElementById("ascending_link").style.background="";
	document.getElementById("descending_link").style.background="";
	document.getElementById("chronological_link").style.background="#C2D1FF";
	document.getElementById("bookmark_list").innerHTML=originalBookmarksListContent;
}



