// Created by John Liaperdos - August 03, 2015
// Modified: August 27, 2015

// preload images
	var first_page_Image=new Image();
    first_page_Image.src="../images/misc/first_page.png";
	var previous_page_Image=new Image();
    previous_page_Image.src="../images/misc/previous_page.png";
	var next_page_Image=new Image();
    next_page_Image.src="../images/misc/next_page.png";
	var last_page_Image=new Image();
    last_page_Image.src="../images/misc/last_page.png";
	var memorize_page_Image=new Image();
    memorize_page_Image.src="../images/misc/memorize_page.png";
	var go_to_memorized_page_Image=new Image();
    go_to_memorized_page_Image.src="../images/misc/go_to_memorized_page.png";
	var go_to_page_Image=new Image();
    go_to_page_Image.src="../images/misc/go_to_page.png";
	var pages_Image=new Image();
    pages_Image.src="../images/misc/pages.png";	
	

var setIntervalVar;
var memorizedPagePostion;
var memorizedPageNumber;
var currentPageNumberVal;

function launchUpdatePages(){
	if(checkIfSettingEnabled(3)) //page navigation is enabled, or default settings apply
	{	
		setIntervalVar=setInterval(updatePages,3000);
		createPageNavigation();
	};
}

function jumpToChapterPage(mode) { // mode = 'first', 'last', 'previous', 'next'
	if(document.getElementById('currentPageDiv')===null){return};
	clearInterval(setIntervalVar);
	if(mode=='first')
	{
		currentPageNumberVal=1;
		if(checkIfSettingEnabled(7)) //scroll effect is enabled, or default settings apply
		{
			$("html, body").animate({ scrollTop: 0 }, 600);
		}
		else
		{
			window.scrollTo(0, 0);
		};
		document.getElementById('currentPageDiv').innerHTML=1; // update page number
		setIntervalVar=setInterval(updatePages,3000);
		return;
	};
	// calculate pages
		var total_document_height=calculateTotalPageHeight();
		var page_height=calculateScreenHeight();
		var total_number_of_pages=Math.ceil(total_document_height/page_height);
		var new_page_number;
	// find new page numbers
		if(mode=='previous')
		{
			new_page_number=currentPageNumberVal-1;
			if(new_page_number<1)
			{
				new_page_number=1;
			};
		};
		if(mode=='next')
		{
			new_page_number=currentPageNumberVal+1;
			if(new_page_number>total_number_of_pages)
			{
				new_page_number=total_number_of_pages;
			};
		};
		if(mode=='last')
		{
			new_page_number=total_number_of_pages;
		};	
		currentPageNumberVal=new_page_number;
	// find scroll positions
		var scrollposition=(new_page_number-1)*page_height;
	// scroll to position
		if(checkIfSettingEnabled(7)) //scroll effect is enabled, or default settings apply
		{
			$("html, body").animate({ scrollTop: scrollposition }, 600);
		}
		else
		{
			window.scrollTo(0, scrollposition);
		};
		document.getElementById('currentPageDiv').innerHTML=new_page_number; // update page number
		setIntervalVar=setInterval(updatePages,3000);			
		return;
}

function createPageNavigation(){
	// create div
		// first page button
		var firstPageElement = document.createElement("img");
		firstPageElement.src=first_page_Image.src;
		firstPageElement.alt="";
		firstPageElement.style.width="20px";
		firstPageElement.style.height="20px";
		firstPageElement.title="πρώτη σελίδα";
		firstPageElement.className="toolbutton";
		firstPageElement.onclick=function(){jumpToChapterPage('first');};
		
		// previous page button
		var previousPageElement = document.createElement("img");
		previousPageElement.src=previous_page_Image.src;
		previousPageElement.alt="";
		previousPageElement.style.width="20px";
		previousPageElement.style.height="20px";
		previousPageElement.title="προηγούμενη σελίδα";
		previousPageElement.className="toolbutton";
		previousPageElement.onclick=function(){jumpToChapterPage('previous');};
		
		// next page button
		var nextPageElement = document.createElement("img");
		nextPageElement.src=next_page_Image.src;
		nextPageElement.alt="";
		nextPageElement.style.width="20px";
		nextPageElement.style.height="20px";
		nextPageElement.title="επόμενη σελίδα";
		nextPageElement.className="toolbutton";
		nextPageElement.onclick=function(){jumpToChapterPage('next');};
		
		// last page button
		var lastPageElement = document.createElement("img");
		lastPageElement.src=last_page_Image.src;
		lastPageElement.alt="";
		lastPageElement.style.width="20px";
		lastPageElement.style.height="20px";
		lastPageElement.title="τελευταία σελίδα";
		lastPageElement.className="toolbutton";
		lastPageElement.onclick=function(){jumpToChapterPage('last');};	

		// memorize page button
		var memorizePageElement = document.createElement("img");
		memorizePageElement.src=memorize_page_Image.src;
		memorizePageElement.alt="";
		memorizePageElement.style.width="20px";
		memorizePageElement.style.height="20px";
		memorizePageElement.title="απομνημόνευση τρέχουσας σελίδας";
		memorizePageElement.className="toolbutton";
		memorizePageElement.onclick=function(){memorizeCurrentPage();};	

		// memorized page container div
		var memorizedPageDivElement = document.createElement("div");
		memorizedPageDivElement.id="memorizedPageDiv";
		memorizedPageDivElement.style.width="40px";
		memorizedPageDivElement.style.display="inline-block";
		memorizedPageDivElement.style.textAlign="center";
		memorizedPageDivElement.style.fontWeight="bold";
		memorizedPageDivElement.style.fontSize="12px";

		// goto memorized page button
		var gotoMemorizedPageElement = document.createElement("img");
		gotoMemorizedPageElement.src=go_to_memorized_page_Image.src;
		gotoMemorizedPageElement.alt="";
		gotoMemorizedPageElement.style.width="20px";
		gotoMemorizedPageElement.style.height="20px";
		gotoMemorizedPageElement.title="μετάβαση στην απομνημονευμένη σελίδα";
		gotoMemorizedPageElement.className="toolbutton";
		gotoMemorizedPageElement.onclick=function(){jumpToMemorizedPosition();};

		// goto page text input field
		var gotoPageInputElement = document.createElement("input");
		gotoPageInputElement.id="gotoPageInputText";
		gotoPageInputElement.type="text";
		gotoPageInputElement.style.fontSize="12px";
		gotoPageInputElement.style.width="27px";
		gotoPageInputElement.style.height="10px";
		gotoPageInputElement.style.marginRight="7px";
		gotoPageInputElement.title="πληκτρολογήστε αριθμό σελίδας";
		gotoPageInputElement.oninput=function(){checkInputNumber();};

		// goto page button
		var gotoPageButtonElement = document.createElement("img");
		gotoPageButtonElement.src=go_to_page_Image.src;
		gotoPageButtonElement.alt="";
		gotoPageButtonElement.style.width="20px";
		gotoPageButtonElement.style.height="20px";
		gotoPageButtonElement.title="μετάβαση στον δοσμένο αριθμό σελίδας";
		gotoPageButtonElement.className="toolbutton";
		gotoPageButtonElement.onclick=function(){jumpToUserDefinedPosition();};		
		
		// assemble container div
		var containerElement = document.createElement("div");
		containerElement.id="pageNavigationDiv";
		containerElement.className="page_navigation_div";
		containerElement.style.fontSize="16px";
	
		// append content to container div
		containerElement.appendChild(firstPageElement);
		containerElement.appendChild(previousPageElement);
		containerElement.appendChild(nextPageElement);	
		containerElement.appendChild(lastPageElement);	
		containerElement.appendChild(memorizePageElement);	
		containerElement.appendChild(memorizedPageDivElement);
		containerElement.appendChild(gotoMemorizedPageElement);
		containerElement.appendChild(gotoPageInputElement);		
		containerElement.appendChild(gotoPageButtonElement);	

		// add container to document
		document.body.appendChild(containerElement);
		
		// make container visible
		document.getElementById('pageNavigationDiv').style.display='inline-block';	
}

function memorizeCurrentPage(){
	// calculations
		var page_height=calculateScreenHeight();
		var current_position=getCurrentPosition();
		var current_page_number=Math.ceil(current_position/page_height)+1;
	// store to global variables
		memorizedPageNumber=current_page_number;
		memorizedPagePosition=current_position;
	// show memorized page
		document.getElementById("memorizedPageDiv").innerHTML=memorizedPageNumber;
}

function jumpToMemorizedPosition(){
	if(document.getElementById('currentPageDiv')===null){return};
	if(document.getElementById("memorizedPageDiv").innerHTML==''){return};
	clearInterval(setIntervalVar);
	if(checkIfSettingEnabled(7)) //scroll effect is enabled, or default settings apply
	{
		$("html, body").animate({ scrollTop: memorizedPagePosition }, 600);
	}
	else
	{
		window.scrollTo(0, memorizedPagePosition);
	};	
	document.getElementById('currentPageDiv').innerHTML=memorizedPageNumber; // update page number
	setIntervalVar=setInterval(updatePages,3000);	
}

function jumpToUserDefinedPosition(){
	if(document.getElementById('currentPageDiv')===null){return};
	input_text_element=document.getElementById("gotoPageInputText");
	if(isNaN(parseInt(input_text_element.value,10))||(input_text_element.value!=parseInt(input_text_element.value,10)))
	{
		input_text_element.style.color="white";
		input_text_element.style.fontWeight="bold";
		input_text_element.style.backgroundColor="red";
		input_text_element.title="επιτρέπεται μόνο αριθμός";
		if(input_text_element.value==''){input_text_element.title="συμπληρώστε το πεδίο";};
		return;
	};
	user_defined_page_number=parseInt(input_text_element.value,10);
	// calculations
		var total_document_height=calculateTotalPageHeight();
		var page_height=calculateScreenHeight();
		var total_number_of_pages=Math.ceil(total_document_height/page_height);
	if(user_defined_page_number<1 || user_defined_page_number>total_number_of_pages)
	{
		input_text_element.style.color="white";
		input_text_element.style.fontWeight="bold";
		input_text_element.style.backgroundColor="red";
		input_text_element.title="αριθμός σελίδας εκτός ορίων";
		return;
	};
	clearInterval(setIntervalVar);
	if(checkIfSettingEnabled(7)) //scroll effect is enabled, or default settings apply
	{
		$("html, body").animate({ scrollTop: (user_defined_page_number-1)*page_height }, 600);
	}
	else
	{
		window.scrollTo(0, (user_defined_page_number-1)*page_height);
	};		
	document.getElementById('currentPageDiv').innerHTML=user_defined_page_number; // update page number
	setIntervalVar=setInterval(updatePages,3000);	
}

function checkInputNumber(){
	input_text_element=document.getElementById("gotoPageInputText");
	input_text_element.style.color="black";
	input_text_element.style.backgroundColor="white";
	input_text_element.style.fontWeight="normal";
	input_text_element.title="πληκτρολογήστε αριθμό σελίδας";
	if(isNaN(parseInt(input_text_element.value,10))||(input_text_element.value!=parseInt(input_text_element.value,10) && input_text_element.value!=''))
	{
		input_text_element.style.color="white";
		input_text_element.style.fontWeight="bold";		
		input_text_element.style.backgroundColor="red";
		input_text_element.title="επιτρέπεται μόνο αριθμός";
		if(input_text_element.value==''){input_text_element.title="συμπληρώστε το πεδίο";};
		return;
	};
	user_defined_page_number=parseInt(input_text_element.value,10);
	// calculations
		var total_document_height=calculateTotalPageHeight();
		var page_height=calculateScreenHeight();
		var total_number_of_pages=Math.ceil(total_document_height/page_height);
	if(user_defined_page_number<1 || user_defined_page_number>total_number_of_pages)
	{
		input_text_element.style.color="white";
		input_text_element.style.fontWeight="bold";		
		input_text_element.style.backgroundColor="red";
		input_text_element.title="αριθμός σελίδας εκτός ορίων";
		return;
	};
}

function updatePages(){
	// calculate pages
		var total_document_height=calculateTotalPageHeight();
		var page_height=calculateScreenHeight();
		var total_number_of_pages=Math.ceil(total_document_height/page_height);
		var current_position=getCurrentPosition();
		var current_page_number=Math.ceil(current_position/page_height)+1;
		currentPageNumberVal=current_page_number;
	// draw on page   
		if (typeof(document.getElementById("pageNumbersDiv")) == 'undefined' || document.getElementById("pageNumbersDiv") == null)
		{
			// create div
				// pages image
				var pagesImageElement = document.createElement("img");
				pagesImageElement.src=pages_Image.src;
				pagesImageElement.alt="";
				pagesImageElement.width=77;
				pagesImageElement.style.width="77px";
				pagesImageElement.style.height="48px";
				
				// current page div
				var currentpagedivelement = document.createElement("div");
				currentpagedivelement.id="currentPageDiv";
				currentpagedivelement.style.width="30px";
				currentpagedivelement.style.position="absolute";
				currentpagedivelement.style.textAlign="center";
				currentpagedivelement.style.fontSize="14px";
				currentpagedivelement.style.top="20px";
				currentpagedivelement.style.left="5px";
				
				// current page text
				var pageTextNode = document.createTextNode(current_page_number); 
				
				// add current page text to its div
				currentpagedivelement.appendChild(pageTextNode);
				
				// total pages div
				var totalpagesdivelement = document.createElement("div");
				totalpagesdivelement.id="totalPagesDiv";
				totalpagesdivelement.style.width="21px";
				totalpagesdivelement.style.position="absolute";
				totalpagesdivelement.style.textAlign="center";
				totalpagesdivelement.style.fontSize="12px";
				totalpagesdivelement.style.top="17px";
				totalpagesdivelement.style.right="12px";								
				
				// total pages text
				var totalPagesTextNode = document.createTextNode(total_number_of_pages); 
				
				// add total pages text to its div
				totalpagesdivelement.appendChild(totalPagesTextNode);				
				
				// assemble container div
				var divelement = document.createElement("div");
				divelement.id="pageNumbersDiv";
				divelement.title="σελίδα "+current_page_number+" από "+total_number_of_pages;
				divelement.className="pages_div";
			
				// append content to container div
				divelement.appendChild(pagesImageElement);
				divelement.appendChild(currentpagedivelement);
				divelement.appendChild(totalpagesdivelement);					

				// add container to document
				document.body.appendChild(divelement);
				
				// make container visible
				document.getElementById('pageNumbersDiv').style.display='inline-block';
		}
		else // update page numbers
		{
			document.getElementById('currentPageDiv').innerHTML=current_page_number;
			document.getElementById('totalPagesDiv').innerHTML=total_number_of_pages;
			document.getElementById('pageNumbersDiv').title="σελίδα "+current_page_number+" από "+total_number_of_pages;			
		};	
}

function calculateTotalPageHeight(){
	var body = document.body,
		html = document.documentElement;

	var pageHeight = Math.max( body.scrollHeight, body.offsetHeight, 
						   html.clientHeight, html.scrollHeight, html.offsetHeight );
	return pageHeight;
}

function calculateScreenHeight(){
	var screenHeight = window.innerHeight
	|| document.documentElement.clientHeight
	|| document.body.clientHeight;
	// if book menu (floatdiv) is horizontal, subtract its height from Screen height!
		floatdiv_element=document.getElementById('floatdiv');
		if(floatdiv_element.className=='floatdiv_horizontal')
		{
			screenHeight=screenHeight-parseInt(floatdiv_element.offsetHeight,10);
		};
	return screenHeight;
}

function getCurrentPosition(){
    return $(window).scrollTop();
}

