// Created  by John Liaperdos and George Theophanous, July 2015

var R_val=1000; // in Ohms
var VS_val=0;
var VB_val=-10;
var VZ_val=5;

function initializeZener(){
	document.getElementById('VB_text').textContent='-10V';
	document.getElementById('VS_text').textContent='0Vp';
	document.getElementById('R_text').textContent='1kΩ';
	document.getElementById('ammeter_text').textContent='0';	
	document.getElementById('voltmeter_text').textContent='0';
	document.getElementById('output_voltmeter_text').textContent='0';
	document.getElementById('VZ_text').innerHTML='Τάση Zener (=5V)';
	findMeterValues();
}

function refreshData(action_code){
	if (action_code==1)
	{
		if(VS_val>0)
		{
			VS_val=VS_val-0.5;
		}		
	};
	if (action_code==2)
	{
		if(VS_val<5)
		{
			VS_val=VS_val+0.5;
		}		
	};
	if (action_code==3)
	{
		if(VB_val>-10)
		{
			VB_val=VB_val-0.5;			
		}	
	};
	if (action_code==4)
	{
		if(VB_val<10)
		{
			VB_val=VB_val+0.5;			
		}	
	};
	if (action_code==5)
	{
		if(R_val>1000)
		{
			R_val=R_val-1000;			
		}	
	};
	if (action_code==6)
	{
		if(R_val<9000)
		{
			R_val=R_val+1000;			
		}		
	};	
	if (action_code==7)
	{
		if(VZ_val>3)
		{
			VZ_val=VZ_val-1;			
		}		
	};
	if (action_code==8)
	{
		if(VZ_val<9)
		{
			VZ_val=VZ_val+1;			
		}		
	};	
	document.getElementById('VB_text').textContent=VB_val+'V';
	document.getElementById('VS_text').textContent=VS_val+'Vp';
	document.getElementById('R_text').textContent=R_val/1000+'kΩ';
	document.getElementById('ammeter_text').textContent='0';	
	document.getElementById('voltmeter_text').textContent='0';
	document.getElementById('VZ_text').innerHTML='Τάση Zener (='+VZ_val+'V)'	
	drawResults();
	findMeterValues();
}	

function drawResults() {

		var svg = document.getElementById('interactive_01').children[1];
		var origin = { //origin of axes
			x: 100,
			y: 100
		};
		var amplitude_in = 10*VS_val; // wave amplitude
		var rarity_in = 1; // point spacing
		var freq_in = 0.1; // angular frequency
		var phase_in = 20; // phase angle
		var amplitude_out = -amplitude_in/10; // wave amplitude
		var rarity_out = 1; // point spacing
		var freq_out = 0.1; // angular frequency
		var phase_out = 20; // phase angle
		
		// clear old figure
			while (svg.hasChildNodes()) {
				svg.removeChild(svg.lastChild);
			}
		
		// draw axes
			var axis1 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis1.setAttribute('x1', '50');
			axis1.setAttribute('y1', '-10');
			axis1.setAttribute('x2', '50');
			axis1.setAttribute('y2', '200');
			axis1.setAttribute('style', 'stroke:black;stroke-width:1');
			svg.appendChild(axis1);
			var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis2.setAttribute('x1', '0');
			axis2.setAttribute('y1', '100');
			axis2.setAttribute('x2', '500');
			axis2.setAttribute('y2', '100');
			axis2.setAttribute('style', 'stroke:black;stroke-width:1');
			svg.appendChild(axis2);	
			var text_V = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_V.setAttribute('x', '40');
			text_V.setAttribute('y', '-5');
			text_V.setAttribute('text-anchor', 'end');
			text_V.textContent ='V';
			svg.appendChild(text_V);
			var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_t.setAttribute('x', '500');
			text_t.setAttribute('y', '120');
			text_t.setAttribute('text-anchor', 'end');
			text_t.textContent ='t';
			svg.appendChild(text_t);
		// draw axis ticks
			for (var i = 0; i < 11; i++) {
				var axis = document.createElementNS("http://www.w3.org/2000/svg", "line");
				axis.setAttribute('x1', '50');
				axis.setAttribute('y1', 20*i);
				axis.setAttribute('x2', '500');
				axis.setAttribute('y2', 20*i);
				axis.setAttribute('style', 'stroke:gray;stroke-width:0.5');
				svg.appendChild(axis);
				var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
				text_t.setAttribute('x', '48');
				text_t.setAttribute('y', 20*i);
				text_t.setAttribute('text-anchor', 'end');
				text_t.setAttribute('style', 'font-size:9px');
				text_t.textContent =10-2*i;
				svg.appendChild(text_t);				
			}
			
		for (var i = -100; i < 400; i++) {			
			var line_in = document.createElementNS("http://www.w3.org/2000/svg", "line");

			line_in.setAttribute('id', 'svg_line_in');
			line_in.setAttribute('x1', (i - 1) * rarity_in + origin.x);
			line_in.setAttribute('y1', -10*VB_val+Math.sin(freq_in * (i - 1 + phase_in)) * amplitude_in + origin.y);

			line_in.setAttribute('x2', i * rarity_in + origin.x);
			line_in.setAttribute('y2', -10*VB_val+Math.sin(freq_in * (i + phase_in)) * amplitude_in + origin.y);

			line_in.setAttribute('style', "stroke:red;stroke-width:2.5");
			
			var line_out = document.createElementNS("http://www.w3.org/2000/svg", "line");

			line_out.setAttribute('id', 'svg_line_out');
			line_out.setAttribute('x1', (i - 1) * rarity_out + origin.x);
			sine_val=Math.sin(freq_out * (i - 1 + phase_out)) * amplitude_out;
			sine_val_plus_offset=VB_val+sine_val;
			y_val=sine_val_plus_offset;
			if(sine_val_plus_offset>VZ_val) y_val=VZ_val;
			if(sine_val_plus_offset<0) y_val=0;

			line_out.setAttribute('y1', -10*y_val+origin.y);

			sine_val=Math.sin(freq_out * (i + phase_out)) * amplitude_out;
			y_val=sine_val_plus_offset;
			if(sine_val_plus_offset>VZ_val) y_val=VZ_val;
			if(sine_val_plus_offset<0) y_val=0;

			line_out.setAttribute('x2', i * rarity_out + origin.x);
			line_out.setAttribute('y2', -10*y_val + origin.y);

			line_out.setAttribute('style', "stroke:green;stroke-width:2.5");    

			svg.appendChild(line_in);
			svg.appendChild(line_out);
		}
}

function findMeterValues(){
	if(VS_val!=0)
	{
		document.getElementById('ammeter_text').textContent='';	
		document.getElementById('voltmeter_text').textContent='';
		document.getElementById('output_voltmeter_text').textContent='';
		return;
	}
	Vout_val=VB_val;
	I_val=0;
	if(VB_val>VZ_val) 
	{
		Vout_val=VZ_val;
		I_val=Math.round(100000*(VB_val-VZ_val)/R_val)/100;
	}		
	if(VB_val<=0) 
	{
		Vout_val=0;
		I_val=(Math.round(100000*VB_val/R_val))/100;
	}	
	document.getElementById('ammeter_text').textContent=I_val;	
	document.getElementById('voltmeter_text').textContent=VB_val;
	document.getElementById('output_voltmeter_text').textContent=Vout_val;	
}