// Created  by John Liaperdos and George Theophanous, August 2015

var R1_val=1;
var R2_val=1;
var V_supply_val=5;
var V_in_val=1;

function initializeAmplifier(){
	document.getElementById('Vpos_in_SVG').textContent='+Vsup=+5V';
	document.getElementById('Vneg_in_SVG').textContent='-Vsup=-5V';
	document.getElementById('R1_in_SVG').textContent='R1=1kΩ';
	document.getElementById('R2_in_SVG').textContent='R2=1kΩ';	
	document.getElementById('Vin_in_SVG').textContent='Vin (1Vp)';
	document.getElementById('Vout_in_SVG').textContent='Vout (-1Vp)';
}

function checkVoltageRanges(Vin_value,Vsupply_value){
	checkVoltageRangesResult=true;
	if(Math.abs(Vin_value)>10 || Math.abs(Vsupply_value)>10)
	{
		checkVoltageRangesResult=false;
	}
	return checkVoltageRangesResult;
}

function refreshData(action_code){
	if (action_code==1)
	{
		if(checkVoltageRanges(V_in_val-1,V_supply_val))
		{
			V_in_val=V_in_val-1;
		}		
	};
	if (action_code==2)
	{
		if(checkVoltageRanges(V_in_val+1,V_supply_val))
		{
			V_in_val=V_in_val+1;
		}		
	};
	if (action_code==3)
	{
		if(R1_val>1)
		{
			R1_val=R1_val-1;
			if(!checkVoltageRanges(V_in_val,V_supply_val))
			{
				R1_val=R1_val+1;
			}			
		}	
	};
	if (action_code==4)
	{
		R1_val=R1_val+1;
		if(!checkVoltageRanges(V_in_val,V_supply_val))
		{
			R1_val=R1_val-1;
		}		
	};
	if (action_code==5)
	{
		if(R2_val>1)
		{
			R2_val=R2_val-1;
			if(!checkVoltageRanges(V_in_val,V_supply_val))
			{
				R2_val=R2_val+1;
			}			
		}	
	};
	if (action_code==6)
	{
		R2_val=R2_val+1;
		if(!checkVoltageRanges(V_in_val,V_supply_val))
		{
			R2_val=R2_val-1;
		}		
	};	
	if (action_code==7)
	{
		if(V_supply_val>1)
		{
			V_supply_val=V_supply_val-1;
			if(!checkVoltageRanges(V_in_val,V_supply_val))
			{
				V_supply_val=V_supply_val+1;
			}			
		}		
	};
	if (action_code==8)
	{
		if(V_supply_val<10)
		{
			V_supply_val=V_supply_val+1;
			if(!checkVoltageRanges(V_in_val,V_supply_val))
			{
				V_supply_val=V_supply_val-1;
			}			
		}		
	};		
	invertingAmplifier(R1_val,R2_val,V_in_val,V_supply_val);
	document.getElementById('Vpos_in_SVG').textContent='+Vsup=+'+V_supply_val+'V';
	document.getElementById('Vneg_in_SVG').textContent='-Vsup=-'+V_supply_val+'V';
	document.getElementById('R1_in_SVG').textContent='R1='+R1_val+'kΩ';
	document.getElementById('R2_in_SVG').textContent='R2='+R2_val+'kΩ';	
	document.getElementById('Vin_in_SVG').textContent='Vin ('+V_in_val+'Vp)';
	output_amplitude=Math.round(100*Math.min(Math.abs(V_in_val)*(R2_val/R1_val),V_supply_val))/100;
	if(V_in_val>0)
	{
		output_amplitude=-output_amplitude;
	}
	document.getElementById('Vout_in_SVG').textContent='Vout ('+output_amplitude+'Vp)';	
}	

function invertingAmplifier(R1_val,R2_val,Vp_in,Vsup) {
	if(checkVoltageRanges(Vp_in,Vsup))
	{
		var svg = document.getElementById('interactive_01').children[1];
		var origin = { //origin of axes
			x: 100,
			y: 100
		};
		Vp_in=10*Vp_in;
		Vsup=10*Vsup;
		var amplitude_in = Vp_in; // wave amplitude
		var rarity_in = 1; // point spacing
		var freq_in = 0.1; // angular frequency
		var phase_in = 20; // phase angle
		var amplitude_out = -Vp_in*(R2_val/R1_val); // wave amplitude
		var rarity_out = 1; // point spacing
		var freq_out = 0.1; // angular frequency
		var phase_out = 20; // phase angle
		
		// clear figure
			while (svg.hasChildNodes()) {
				svg.removeChild(svg.lastChild);
			}
		
		// draw axes
			var axis1 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis1.setAttribute('x1', '50');
			axis1.setAttribute('y1', '-10');
			axis1.setAttribute('x2', '50');
			axis1.setAttribute('y2', '200');
			axis1.setAttribute('style', 'stroke:black;stroke-width:1');
			svg.appendChild(axis1);
			var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis2.setAttribute('x1', '0');
			axis2.setAttribute('y1', '100');
			axis2.setAttribute('x2', '500');
			axis2.setAttribute('y2', '100');
			axis2.setAttribute('style', 'stroke:black;stroke-width:1');
			svg.appendChild(axis2);	
			var text_V = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_V.setAttribute('x', '40');
			text_V.setAttribute('y', '-5');
			text_V.setAttribute('text-anchor', 'end');
			text_V.textContent ='V';
			svg.appendChild(text_V);
			var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_t.setAttribute('x', '500');
			text_t.setAttribute('y', '120');
			text_t.setAttribute('text-anchor', 'end');
			text_t.textContent ='t';
			svg.appendChild(text_t);

		//draw Vsup+ line
			var line_Vsup_pos = document.createElementNS("http://www.w3.org/2000/svg", "line");
			line_Vsup_pos.setAttribute('x1', -100 + origin.x);
			line_Vsup_pos.setAttribute('y1', -Vsup + origin.y);
			line_Vsup_pos.setAttribute('x2', 400 + origin.x);
			line_Vsup_pos.setAttribute('y2', -Vsup + origin.y);		
			line_Vsup_pos.setAttribute('style', "stroke:green;stroke-width:1");    
			svg.appendChild(line_Vsup_pos);
		//draw Vsup+ value
			var text_Vsup_pos = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_Vsup_pos.setAttribute('x', 400 + origin.x);
			text_Vsup_pos.setAttribute('y', -Vsup + origin.y);
			text_Vsup_pos.setAttribute('fill', 'green');
			text_Vsup_pos.textContent = '+Vsup = '+Vsup/10+'V';
			svg.appendChild(text_Vsup_pos);
		//draw Vsup- line
			var line_Vsup_neg = document.createElementNS("http://www.w3.org/2000/svg", "line");
			line_Vsup_neg.setAttribute('x1', -100 + origin.x);
			line_Vsup_neg.setAttribute('y1', Vsup + origin.y);
			line_Vsup_neg.setAttribute('x2', 400 + origin.x);
			line_Vsup_neg.setAttribute('y2', Vsup + origin.y);		
			line_Vsup_neg.setAttribute('style', "stroke:green;stroke-width:1");    
			svg.appendChild(line_Vsup_neg);
		//draw Vsup- value
			var text_Vsup_neg = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_Vsup_neg.setAttribute('x', 400 + origin.x);
			text_Vsup_neg.setAttribute('y', Vsup + origin.y);
			text_Vsup_neg.setAttribute('fill', 'green');
			text_Vsup_neg.textContent = '-Vsup = -'+Vsup/10+'V';
			svg.appendChild(text_Vsup_neg);			
			
		for (var i = -100; i < 400; i++) {
			
			var line_in = document.createElementNS("http://www.w3.org/2000/svg", "line");

			line_in.setAttribute('id', 'svg_line_in');
			line_in.setAttribute('x1', (i - 1) * rarity_in + origin.x);
			line_in.setAttribute('y1', Math.sin(freq_in * (i - 1 + phase_in)) * amplitude_in + origin.y);

			line_in.setAttribute('x2', i * rarity_in + origin.x);
			line_in.setAttribute('y2', Math.sin(freq_in * (i + phase_in)) * amplitude_in + origin.y);

			line_in.setAttribute('style', "stroke:blue;stroke-width:2");
			
			var line_out = document.createElementNS("http://www.w3.org/2000/svg", "line");

			line_out.setAttribute('id', 'svg_line_out');
			line_out.setAttribute('x1', (i - 1) * rarity_out + origin.x);
			sine_val=Math.sin(freq_out * (i - 1 + phase_out)) * amplitude_out;
			if(sine_val>=0 && sine_val<=Vsup)
			{
				y_val=sine_val;
			}
			if(sine_val>Vsup)
			{
				y_val=Vsup;
			}
			if(sine_val<0 && sine_val>=-Vsup)
			{
				y_val=sine_val;
			}
			if(sine_val<-Vsup)
			{
				y_val=-Vsup;
			}
			line_out.setAttribute('y1', y_val+origin.y);

			sine_val=Math.sin(freq_out * (i + phase_out)) * amplitude_out;
			if(sine_val>=0 && sine_val<=Vsup)
			{
				y_val=sine_val;
			}
			if(sine_val>Vsup)
			{
				y_val=Vsup;
			}
			if(sine_val<0 && sine_val>=-Vsup)
			{
				y_val=sine_val;
			}
			if(sine_val<-Vsup)
			{
				y_val=-Vsup;
			}		
			line_out.setAttribute('x2', i * rarity_out + origin.x);
			line_out.setAttribute('y2', y_val + origin.y);

			line_out.setAttribute('style', "stroke:magenta;stroke-width:2");    

			svg.appendChild(line_in);
			svg.appendChild(line_out);
		}		
	}		

}