// Created  by John Liaperdos and George Theophanous, August 2015

var V1=0;
var V2=0;
var u1=0;
var u2=0;
var R1=1; // in kOhms
var R2=1; // in kOhms
var Rf=1; // in kOhms
var f1=1; // in kHz
var f2=2; // in kHz

function initializeSummingAmplifier(){
	document.getElementById('V1_text').textContent='V1=0V';
	document.getElementById('u1_text').textContent='u1=0V';
	document.getElementById('V2_text').textContent='V2=0V';
	document.getElementById('u2_text').textContent='u2=0V';
	document.getElementById('R1_text').textContent='R1=1kΩ';
	document.getElementById('R2_text').textContent='R2=1kΩ';
	document.getElementById('Rf_text').textContent='Rf=1kΩ';
	document.getElementById('f1_text').textContent='f1=1kHz';
	document.getElementById('f2_text').textContent='f2=2kHz';
	drawPlots();
}

function refreshData(action_code){
	if (action_code==2)
	{
		if (V1<5) V1=V1+1;
	};
	if (action_code==1)
	{
		if (V1>-5) V1=V1-1;		
	};
	if (action_code==4)
	{
		if (u1<5) u1=u1+1;
	};
	if (action_code==3)
	{
		if (u1>-5) u1=u1-1;		
	};	
	if (action_code==6)
	{
		if (f1<4) f1=f1+1;
	};
	if (action_code==5)
	{
		if (f1>1) f1=f1-1;		
	};	
	if (action_code==8)
	{
		if (V2<5) V2=V2+1;
	};
	if (action_code==7)
	{
		if (V2>-5) V2=V2-1;		
	};
	if (action_code==10)
	{
		if (u2<5) u2=u2+1;
	};
	if (action_code==9)
	{
		if (u2>-5) u2=u2-1;		
	};	
	if (action_code==12)
	{
		if (f2<4) f2=f2+1;
	};
	if (action_code==11)
	{
		if (f2>1) f2=f2-1;		
	};		
	if (action_code==14)
	{
		if (R1<10) R1=R1+1;
	};
	if (action_code==13)
	{
		if (R1>1) R1=R1-1;		
	};
	if (action_code==16)
	{
		if (R2<10) R2=R2+1;
	};
	if (action_code==15)
	{
		if (R2>1) R2=R2-1;		
	};
	if (action_code==18)
	{
		if (Rf<10) Rf=Rf+1;
	};
	if (action_code==17)
	{
		if (Rf>1) Rf=Rf-1;		
	};
	document.getElementById('V1_text').textContent='V1='+V1+'V';
	document.getElementById('u1_text').textContent='u1='+u1+'V';
	document.getElementById('V2_text').textContent='V2='+V2+'V';
	document.getElementById('u2_text').textContent='u2='+u2+'V';
	document.getElementById('R1_text').textContent='R1='+R1+'kΩ';
	document.getElementById('R2_text').textContent='R2='+R2+'kΩ';
	document.getElementById('Rf_text').textContent='Rf='+Rf+'kΩ';
	document.getElementById('f1_text').textContent='f1='+f1+'kHz';
	document.getElementById('f2_text').textContent='f2='+f2+'kHz';
	drawPlots();
}	

function drawPlots() {
		var svg = document.getElementById('summing_amplifier_plots_container');
		
		// clear old plots
			while (svg.hasChildNodes()) {
				svg.removeChild(svg.lastChild);
			}
		
		// draw axes
			// y
			var axis1 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis1.setAttribute('x1', '50');
			axis1.setAttribute('y1', '10');
			axis1.setAttribute('x2', '50');
			axis1.setAttribute('y2', '340');
			axis1.setAttribute('style', 'stroke:black;stroke-width:1.5');
			svg.appendChild(axis1);
			// x1
			var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis2.setAttribute('x1', '0');
			axis2.setAttribute('y1', '65');
			axis2.setAttribute('x2', '650');
			axis2.setAttribute('y2', '65');
			axis2.setAttribute('style', 'stroke:black;stroke-width:1.5');
			svg.appendChild(axis2);	
			// x2
			var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis2.setAttribute('x1', '0');
			axis2.setAttribute('y1', '175');
			axis2.setAttribute('x2', '650');
			axis2.setAttribute('y2', '175');
			axis2.setAttribute('style', 'stroke:black;stroke-width:1.5');
			svg.appendChild(axis2);	
			// xtot
			var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
			axis2.setAttribute('x1', '0');
			axis2.setAttribute('y1', '285');
			axis2.setAttribute('x2', '650');
			axis2.setAttribute('y2', '285');
			axis2.setAttribute('style', 'stroke:black;stroke-width:1.5');
			svg.appendChild(axis2);	
			// ticks
			maxV1=Math.abs(V1)+Math.abs(u1);
			maxV1=Math.max(1,maxV1);
			maxV2=Math.abs(V2)+Math.abs(u2);
			maxV2=Math.max(1,maxV2);
			maxVtot=0;
			for (var i = 0; i < 600; i++) {
				V1_val=V1+u1*Math.sin(f1/10 * (i - 1));
				V2_val=V2+u2*Math.sin(f2/10 * (i - 1));
				V_tot_val=Math.abs(-Rf*V1_val/R1-Rf*V2_val/R2);
				maxVtot=Math.max(maxVtot,V_tot_val);
			}
			maxVtot=Math.max(1,maxVtot);
			
			for(i=1;i<=3;i++)//sweep axes
			{
				for(j=1;j<=2;j++)
				{
					for(k=-1;k<=1;k=k+2)
					{
						var axis2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
						axis2.setAttribute('x1', '45');
						axis2.setAttribute('y1', 65+(i-1)*110-k*55*j/2);
						axis2.setAttribute('x2', '620');
						axis2.setAttribute('y2', 65+(i-1)*110-k*55*j/2);
						if(j==1)
						{
							axis2.setAttribute('style', 'stroke:gray;stroke-width:1');
						}
						else
						{
							axis2.setAttribute('style', 'stroke:orange;stroke-width:1.5');
						};						
						svg.appendChild(axis2);
						if(j==1)
						{
							var text_V = document.createElementNS("http://www.w3.org/2000/svg", "text");
							text_V.setAttribute('x', '622');
							text_V.setAttribute('y', 65+(i-1)*110-k*55*j/2);
							text_V.setAttribute('text-anchor', 'start');
							text_V.setAttribute('style', 'font-size:10px;');
							if(i==1) text_V.setAttribute('fill', 'red');
							if(i==2) text_V.setAttribute('fill', 'blue');
							if(i==3) text_V.setAttribute('fill', 'magenta');
							if(i==1) text_V.textContent =k*maxV1*j/2;
							if(i==2) text_V.textContent =k*maxV2*j/2;
							if(i==3) text_V.textContent =Math.round(100*k*maxVtot*j/2)/100;
							svg.appendChild(text_V);								
						}					
					}
				}
			}
			
			// V mark
			var text_V = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_V.setAttribute('x', '40');
			text_V.setAttribute('y', '15');
			text_V.setAttribute('text-anchor', 'end');
			text_V.textContent ='V';
			svg.appendChild(text_V);
			// t marks
			var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_t.setAttribute('x', '640');
			text_t.setAttribute('y', '80');
			text_t.setAttribute('text-anchor', 'end');
			text_t.textContent ='t';
			svg.appendChild(text_t);
			var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_t.setAttribute('x', '640');
			text_t.setAttribute('y', '190');
			text_t.setAttribute('text-anchor', 'end');
			text_t.textContent ='t';
			svg.appendChild(text_t);
			var text_t = document.createElementNS("http://www.w3.org/2000/svg", "text");
			text_t.setAttribute('x', '640');
			text_t.setAttribute('y', '300');
			text_t.setAttribute('text-anchor', 'end');
			text_t.textContent ='t';
			svg.appendChild(text_t);		
			
		for (var i = 52; i < 620; i++) {
			// scale plots
				pixels_per_volt_V1=55/maxV1;
				pixels_per_volt_V2=55/maxV2;				
				pixels_per_volt_Vtot=55/maxVtot;				
			//V1
				var line_V1 = document.createElementNS("http://www.w3.org/2000/svg", "line");
				line_V1.setAttribute('x1', (i - 1));
				line_V1.setAttribute('y1', 65-(pixels_per_volt_V1*(V1+u1*Math.sin(f1/10 * (i - 52)))));
				line_V1.setAttribute('x2', i);
				line_V1.setAttribute('y2', 65-(pixels_per_volt_V1*(V1+u1*Math.sin(f1/10 * (i - 51)))));
				line_V1.setAttribute('style', "stroke:red;stroke-width:2");
				svg.appendChild(line_V1);
			//V2
				var line_V2 = document.createElementNS("http://www.w3.org/2000/svg", "line");
				line_V2.setAttribute('x1', (i - 1));
				line_V2.setAttribute('y1', 175-(pixels_per_volt_V2*(V2+u2*Math.sin(f2/10 * (i - 52)))));
				line_V2.setAttribute('x2', i);
				line_V2.setAttribute('y2', 175-(pixels_per_volt_V2*(V2+u2*Math.sin(f2/10 * (i - 51)))));
				line_V2.setAttribute('style', "stroke:blue;stroke-width:2");
				svg.appendChild(line_V2);
			//Vtot
				var line_Vtot = document.createElementNS("http://www.w3.org/2000/svg", "line");
				line_Vtot.setAttribute('x1', (i - 1));
				V1_val=V1+u1*Math.sin(f1/10 * (i - 52));
				V2_val=V2+u2*Math.sin(f2/10 * (i - 52));
				V_tot_val=-Rf*V1_val/R1-Rf*V2_val/R2;
				line_Vtot.setAttribute('y1', 285-(pixels_per_volt_Vtot*V_tot_val));
				line_Vtot.setAttribute('x2', i);
				V1_val=V1+u1*Math.sin(f1/10 * (i-51));
				V2_val=V2+u2*Math.sin(f2/10 * (i-51));
				V_tot_val=-Rf*V1_val/R1-Rf*V2_val/R2;				
				line_Vtot.setAttribute('y2', 285-(pixels_per_volt_Vtot*V_tot_val));
				line_Vtot.setAttribute('style', "stroke:magenta;stroke-width:2");
				svg.appendChild(line_Vtot);
		}		
}