// Created  by John Liaperdos and George Theophanous, August 2015

var B_mag=0.1;
var B_phase=0;
var A_mag=1;
var A_phase=180;

function initializeBarkhausen(){
	document.getElementById('alpha_text').textContent='A: 1, 180 deg';
	document.getElementById('beta_text').textContent='β: 0.1, 0 deg';
	document.getElementById('barkhausen_equation').style.display='none';
	drawPlots();
}

function refreshData(action_code){ 
	if (action_code==1)
	{
		if(A_mag>1)
		{
			A_mag=A_mag-1;
		}				
	};
	if (action_code==2)
	{
		if(A_mag<10)
		{
			A_mag=A_mag+1;
		}		
	};
	if (action_code==3)
	{
		if(A_phase>-360)
		{
			A_phase=A_phase-10;
		}				
	};
	if (action_code==4)
	{
		if(A_phase<360)
		{
			A_phase=A_phase+10;
		}		
	};
	if (action_code==5)
	{
		if(B_mag>0.1)
		{
			B_mag=B_mag-0.1;
		}				
	};
	if (action_code==6)
	{
		if(B_mag<1)
		{
			B_mag=B_mag+0.1;
		}		
	};
	if (action_code==7)
	{
		if(B_phase>-360)
		{
			B_phase=B_phase-10;
		}				
	};
	if (action_code==8)
	{
		if(B_phase<360)
		{
			B_phase=B_phase+10;
		}		
	};
	B_mag=Math.round(B_mag*10)/10;	
	document.getElementById('alpha_text').textContent='A: '+A_mag+', '+A_phase+' deg';
	document.getElementById('beta_text').textContent='β: '+B_mag+', '+B_phase+' deg';
	drawPlots();
}

function drawPlots(){
	// vertical 230-280
	// horiz 123-260
	
	// check Barkhausen's criterion
		document.getElementById('barkhausen_equation').style.display='none';
		if(A_mag*B_mag==1 && ((A_phase+B_phase)%360==0)) 
		{
			document.getElementById('barkhausen_equation').style.display='inline';
		};	
	
	// remove older plots
		var wave_container = document.getElementById('wave_container');
		while (wave_container.hasChildNodes()) {
			wave_container.removeChild(wave_container.lastChild);
		}	
		
	// scale y-axes
		blue_scalefactor=1/A_mag;
		document.getElementById('blue_axis_scalefactor').textContent='(x '+(Math.round(100*blue_scalefactor)/100)+')';
		red_green_max_amplitude=Math.max(1,B_mag*A_mag);
		red_green_scalefactor=1/(red_green_max_amplitude);
		document.getElementById('red_green_axis_scalefactor').textContent='(x '+(Math.round(100*red_green_scalefactor)/100)+')';
		
		
	for(i=123; i<260; i++)
	{
		sine_red_current=red_green_scalefactor*12*Math.sin((i-123)/5);
		sine_red_next=red_green_scalefactor*12*Math.sin((i-122)/5);
		A_phase_rads=2*3.14*A_phase/360;
		sine_blue_current=12*Math.sin((i-123)/5+A_phase_rads);
		sine_blue_next=12*Math.sin((i-122)/5+A_phase_rads);
		B_phase_rads=2*3.14*B_phase/360;
		sine_green_current=red_green_scalefactor*B_mag*A_mag*12*Math.sin((i-123)/5+A_phase_rads+B_phase_rads);
		sine_green_next=red_green_scalefactor*B_mag*A_mag*12*Math.sin((i-122)/5+A_phase_rads+B_phase_rads);
		// draw red sine			
			var red_sine_segment = document.createElementNS("http://www.w3.org/2000/svg", "line");
			red_sine_segment.setAttribute('x1', i);
			red_sine_segment.setAttribute('y1', 242.5-sine_red_current);
			red_sine_segment.setAttribute('x2', i+1);
			red_sine_segment.setAttribute('y2', 242.5-sine_red_next);
			red_line_color='red';
			red_sine_segment.setAttribute('style', 'fill:none;stroke:'+red_line_color+';stroke-width:2');
			wave_container.appendChild(red_sine_segment);	
		// draw blue sine
			var blue_sine_segment = document.createElementNS("http://www.w3.org/2000/svg", "line");
			blue_sine_segment.setAttribute('x1', i);
			blue_sine_segment.setAttribute('y1', 270.5-sine_blue_current);
			blue_sine_segment.setAttribute('x2', i+1);
			blue_sine_segment.setAttribute('y2', 270.5-sine_blue_next);
			blue_line_color='blue';
			blue_sine_segment.setAttribute('style', 'fill:none;stroke:'+blue_line_color+';stroke-width:2');
			wave_container.appendChild(blue_sine_segment);
		// draw green sine			
			var green_sine_segment = document.createElementNS("http://www.w3.org/2000/svg", "line");
			green_sine_segment.setAttribute('x1', i);
			green_sine_segment.setAttribute('y1', 242.5-sine_green_current);
			green_sine_segment.setAttribute('x2', i+1);
			green_sine_segment.setAttribute('y2', 242.5-sine_green_next);
			green_line_color='green';
			green_sine_segment.setAttribute('style', 'fill:none;stroke:'+green_line_color+';stroke-width:2');
			wave_container.appendChild(green_sine_segment);				
	}
}





