// Created  by John Liaperdos and George Theophanous, August 2015

var number_of_inverters=5;
var initial_condition=0;
var time_delay=0.5; // in seconds
var timeout_lamp_1;
var timeout_lamp_2;
var timeout_lamp_3;
var timeout_lamp_4;
var timeout_lamp_5;
var paused=false;

function initializeRingOscillator(){
	document.getElementById('feedback_loop_2').style.display='none';
	document.getElementById('feedback_loop_3').style.display='none';
	document.getElementById('feedback_loop_4').style.display='none';
	document.getElementById('initial_condition').textContent=0;
	document.getElementById('time_delay_label').textContent='0.5 s';	
	document.getElementById('lamp_1_color').style.fill='gray';
	document.getElementById('lamp_2_color').style.fill='gray';
	document.getElementById('lamp_3_color').style.fill='gray';
	document.getElementById('lamp_4_color').style.fill='gray';
	document.getElementById('lamp_5_color').style.fill='gray';
	startBlinking();
}

function toggleInitialCondition(){
	if(initial_condition==0)
	{
		initial_condition=1;
		document.getElementById('initial_condition').textContent=1;
	}
	else
	{
		initial_condition=0;
		document.getElementById('initial_condition').textContent=0;
	}
	startBlinking();
}

function increaseDelay(){
	if(time_delay<10)
	{
		time_delay=time_delay+0.1;
	}
	time_delay=Math.round(100*time_delay)/100;
	document.getElementById('time_delay_label').textContent=time_delay+' s';
	startBlinking();
}

function decreaseDelay(){
	if(time_delay>0.1)
	{
		time_delay=time_delay-0.1;
	}
	time_delay=Math.round(100*time_delay)/100;
	document.getElementById('time_delay_label').textContent=time_delay+' s';
	startBlinking();
}

function increaseInverters(){
	if(number_of_inverters<5)
	{
		number_of_inverters=number_of_inverters+1;
	}
	startBlinking();
}

function decreaseInverters(){
	if(number_of_inverters>2)
	{
		number_of_inverters=number_of_inverters-1;
	}
	startBlinking();
}

function showInverters(){
	document.getElementById('feedback_loop_2').style.display='none';
	document.getElementById('feedback_loop_3').style.display='none';
	document.getElementById('feedback_loop_4').style.display='none';
	document.getElementById('feedback_loop_5').style.display='none';
	document.getElementById('lamp_group_3').style.display='none';
	document.getElementById('lamp_group_4').style.display='none';
	document.getElementById('lamp_group_5').style.display='none';	
	document.getElementById('inverter_gate_3').style.display='none';
	document.getElementById('inverter_gate_4').style.display='none';
	document.getElementById('inverter_gate_5').style.display='none';
	document.getElementById('lamp_1_color').style.fill='gray';
	document.getElementById('lamp_2_color').style.fill='gray';
	document.getElementById('lamp_3_color').style.fill='gray';
	document.getElementById('lamp_4_color').style.fill='gray';
	document.getElementById('lamp_5_color').style.fill='gray';	
	if(number_of_inverters>=3)
	{
		document.getElementById('inverter_gate_3').style.display='inline';
		document.getElementById('lamp_group_3').style.display='inline';
	};
	if(number_of_inverters>=4)
	{
		document.getElementById('inverter_gate_4').style.display='inline';
		document.getElementById('lamp_group_4').style.display='inline';
	};	
	if(number_of_inverters==5)
	{
		document.getElementById('inverter_gate_5').style.display='inline';
		document.getElementById('lamp_group_5').style.display='inline';
	};	
	if(number_of_inverters==2)
	{
		document.getElementById('feedback_loop_2').style.display='inline';
	};
	if(number_of_inverters==3)
	{
		document.getElementById('feedback_loop_3').style.display='inline';
	};	
	if(number_of_inverters==4)
	{
		document.getElementById('feedback_loop_4').style.display='inline';
	};	
	if(number_of_inverters==5)
	{
		document.getElementById('feedback_loop_5').style.display='inline';
	};		
	if(initial_condition==0)
	{
		document.getElementById('lamp_1_color').style.fill='yellow';
		document.getElementById('lamp_3_color').style.fill='yellow';
		document.getElementById('lamp_5_color').style.fill='yellow';
	}
	else
	{
		document.getElementById('lamp_2_color').style.fill='yellow';
		document.getElementById('lamp_4_color').style.fill='yellow';			
	};	
}

function startBlinking(){
	showInverters();
	stopBlinking();
	if(number_of_inverters%2!=0)
	{
		timeout_lamp_1 = setTimeout(blinkLampOne,1000*time_delay);
	};	
}

function stopBlinking(){
	clearTimeout(timeout_lamp_1);
	clearTimeout(timeout_lamp_2);
	clearTimeout(timeout_lamp_3);
	clearTimeout(timeout_lamp_4);
	clearTimeout(timeout_lamp_5);
}

function pauseResume(){
	if(number_of_inverters%2!=0)
	{
		if(paused)
		{
			paused=false;
			startBlinking();
			document.getElementById('pause_resume_label').textContent='Παύση';
		}
		else
		{
			paused=true;
			stopBlinking();
			document.getElementById('pause_resume_label').textContent='Συνέχιση';
		};		
	};
}

function blinkLampOne(){
	current_color=document.getElementById('lamp_1_color').style.fill;
	if(current_color=='gray'||current_color=='rgb(128, 128, 128)'||current_color=='#808080')
	{
		document.getElementById('lamp_1_color').style.fill='yellow';
	}
	else
	{
		document.getElementById('lamp_1_color').style.fill='gray';
	};
	timeout_lamp_2 = setTimeout(blinkLampTwo,1000*time_delay);	
}

function blinkLampTwo(){
	current_color=document.getElementById('lamp_2_color').style.fill;
	if(current_color=='gray'||current_color=='rgb(128, 128, 128)'||current_color=='#808080')
	{
		document.getElementById('lamp_2_color').style.fill='yellow';
	}
	else
	{
		document.getElementById('lamp_2_color').style.fill='gray';
	};
	timeout_lamp_3 = setTimeout(blinkLampThree,1000*time_delay);
}

function blinkLampThree(){
	current_color=document.getElementById('lamp_3_color').style.fill;
	if(current_color=='gray'||current_color=='rgb(128, 128, 128)'||current_color=='#808080')
	{
		document.getElementById('lamp_3_color').style.fill='yellow';
	}
	else
	{
		document.getElementById('lamp_3_color').style.fill='gray';
	};
	if(number_of_inverters==3)
	{
		timeout_lamp_1 = setTimeout(blinkLampOne,1000*time_delay);
	}
	else
	{
		timeout_lamp_4 = setTimeout(blinkLampFour,1000*time_delay);
	};
	
}

function blinkLampFour(){
	current_color=document.getElementById('lamp_4_color').style.fill;
	if(current_color=='gray'||current_color=='rgb(128, 128, 128)'||current_color=='#808080')
	{
		document.getElementById('lamp_4_color').style.fill='yellow';
	}
	else
	{
		document.getElementById('lamp_4_color').style.fill='gray';
	};
	timeout_lamp_5 = setTimeout(blinkLampFive,1000*time_delay);	
}

function blinkLampFive(){
	current_color=document.getElementById('lamp_5_color').style.fill;
	if(current_color=='gray'||current_color=='rgb(128, 128, 128)'||current_color=='#808080')
	{
		document.getElementById('lamp_5_color').style.fill='yellow';
	}
	else
	{
		document.getElementById('lamp_5_color').style.fill='gray';
	};
	timeout_lamp_1 = setTimeout(blinkLampOne,1000*time_delay);	
}
