// Created by John Liaperdos - July 26, 2015
// Modified: -

var standard_definition;

 function videoError(e) {
   // video playback failed - handle error
   video_element=document.getElementsByClassName('video')[0];
   switch (e.target.error.code) {
     case e.target.error.MEDIA_ERR_ABORTED:
       //User aborted the video playback.
       break;
     case e.target.error.MEDIA_ERR_NETWORK:
       //A network error caused the video download to fail part-way.
	   if(!standard_definition)
	    {
			formatErrorMessage('Συνέβη σφάλμα δικτύου. Η αναπαραγωγή του video θα συνεχιστεί σε 1 λεπτό σε κανονική ανάλυση (SD). Παρακαλώ, περιμένετε ...');
			toggleVideoResolution(); //switch to SD
		}
		else
		{
			formatErrorMessage('Συνέβη σφάλμα δικτύου. Η αναπαραγωγή του video θα συνεχιστεί σε 1 λεπτό. Παρακαλώ, περιμένετε ...');
		}; 
	   video_element.load(); //reload video
	   video_element.removeAttribute('controls'); // disable controls
	   setTimeout(function(){ hideVideoErrorMessage(); }, 60000);
	   setTimeout(function(){ 
			video_element=document.getElementsByClassName('video')[0];
			// re-enable controls
				video_element.setAttribute('controls','controls');
			// resume video
				video_element.play(); 
	   }, 60000);
       break;
     case e.target.error.MEDIA_ERR_DECODE:
       // The video playback was aborted due to a corruption problem or because the video used features your browser did not support.
		formatErrorMessage('Συνέβη σφάλμα. Μπορείτε να παρακολουθήσετε το video στο YouTube.');	
       break;
     case e.target.error.MEDIA_ERR_SRC_NOT_SUPPORTED:
       //The video could not be loaded, either because the server or network failed or because the format is not supported.
	   if(video_element.canPlayType('video/mp4')=='')
	   {
		   formatErrorMessage('Ο φυλλομετρητής σας δεν υποστηρίζει το συγκεκριμένο video. Μπορείτε να παρακολουθήσετε το video στο YouTube.');
	   }
	   else
	   {
		   formatErrorMessage('Συνέβη σφάλμα. Συστήνεται η ανανέωση της σελίδας του φυλλομετρητή σας ή/και η επιλογή αναπαραγωγής σε διαφορετική ανάλυση (SD/HD). Αν το σφάλμα επιμένει, μπορείτε να παρακολουθήσετε το video στο YouTube.');
	   }
       break;
     default:
       // An unknown error occurred.
	   formatErrorMessage('Συνέβη σφάλμα κατά την αναπαραγωγή του video. Συστήνεται η ανανέωση της σελίδας του φυλλομετρητή σας και η επιλογή αναπαραγωγής σε κανονική ανάλυση (SD). Αν το σφάλμα επιμένει, μπορείτε να παρακολουθήσετε το video στο YouTube.');
       break;
   }
 }
 
 function formatErrorMessage(messageText){
	 errorMessageContainer=document.getElementById('video_error_container');
	 errorMessageContainer.innerHTML=messageText;
	 errorMessageContainer.style.display="inline-block";
 }
 
 function hideVideoErrorMessage(){
	 errorMessageContainer=document.getElementById('video_error_container');
	 errorMessageContainer=document.getElementById('video_error_container');
	 errorMessageContainer.style.display="none";
 }



