// Created by John Liaperdos - April 30, 2015
// Modified: August 27, 2015

var setting = new Array();
/* check if the reading system supports the needed scripting */
	setting['scriptEnabled'] =false;
	setting['webBrowserOrEpub2'] =false;
	if (typeof navigator.epubReadingSystem != "undefined")
		{
			setting['scriptEnabled'] = (
			!navigator.epubReadingSystem.hasFeature('dom-manipulation')
			) ? false : true;					
		}
		else
		{
			setting['scriptEnabled'] =true; // epub2 case, or reader software that does not provide "epubReadingSystem"
			setting['webBrowserOrEpub2'] =true;
		};

function initializeInteractivity() {
	/* exit if the reading system does not support scripting */
		if (!setting['scriptEnabled']) { return; }
	var solutions = document.getElementsByClassName('solution');
	var proofs = document.getElementsByClassName('proof');
	for (var i = 0; i < solutions.length; i++) {
		solutions[i].style.display='none';
	};
	for (var i = 0; i < proofs.length; i++) {
		proofs[i].style.display='none';
	};
					
	/* Un-hide buttons in proof/solution blocks */	
		var buttons_array = document.getElementsByClassName('button');
		for (var i = 0; i < buttons_array.length; i++) {
			buttons_array[i].style.visibility='visible';
		}				
}

// auto-scale SVGs (figures and tables) [can also auto-scale wide MathJax equations]
	var original_SVG_widths = new Array();
	var original_SVG_heights = new Array();	
	var resizeTimer;
	var autoscaleTimer;
	var countSVGAutoscaleInitializationIterations=0;
	function initializeAutoScaleSVGs(){
		// store original SVG dimensions
			var x = document.getElementsByClassName("scalable_SVG");
			var i;
			var initialization_ok=true;
			countSVGAutoscaleInitializationIterations++;
			for (i = 0; i < x.length; i++) {		
					original_SVG_heights[i]=x[i].height;	
					original_SVG_widths[i]=x[i].width;
					// fix iframe scrollbar problem when page is zoomed [Firefox, Safari, Chrome]
						if(x[i].className.indexOf("video")==-1) // bypass if video
						{
							try{
								var y = (x[i].contentWindow || x[i].contentDocument);
								if (y.window) y = y.document;
								var svg_elements=y.getElementsByTagName('svg');
								// set internal svg dimensions
									svg_elements[0].setAttributeNS(null, "width", x[i].width);
									svg_elements[0].setAttributeNS(null, "height", x[i].height);					
									svg_elements[0].setAttributeNS(null, "style", "overflow:hidden");
								// disable scrollbars [Safari]
									x[i].scrolling="no";
								}
							catch(err){
								// svg's not ready yet
								initialization_ok=false;	
							};
						};
			};
			if(initialization_ok==false && countSVGAutoscaleInitializationIterations<=15)
			{
				autoscaleTimer=setTimeout(initializeAutoScaleSVGs, 2000);
				console.log('re-initializing SVG autoscale ...');
			}
			else
			{
				// abort if stalled
					if(countSVGAutoscaleInitializationIterations>15)
					{
						console.log('SVG autoscale initialization failed.');
						return;
					};
				// auto-scale on window resize
					window.addEventListener('resize', function(){
						clearTimeout(autoscaleTimer);
						clearTimeout(resizeTimer);
						resizeTimer = setTimeout(autoScaleSVGs, 100);				
					});
				// perform initial auto-scale
					autoScaleSVGs();
				console.log('SVG autoscale initialized.');
			};		
	}	

	function autoScaleSVGs() 
	{
		var x = document.getElementsByClassName("scalable_SVG");
		var i;
		textWidth=Math.floor(document.getElementById("width_measurement").offsetWidth);
		for (i = 0; i < x.length; i++) {
			// restore original dimensions
				x[i].height=original_SVG_heights[i];	
				x[i].width=original_SVG_widths[i];
			// if fonts are scaled, apply the corresponding scale factor
				x[i].height=parseInt(font_size_contribution_to_image_scale_factor*x[i].height,10);
				x[i].width=parseInt(font_size_contribution_to_image_scale_factor*x[i].width,10);
				
				// set original internal svg dimensions (fixes iframe scrollbar problem when page is zoomed [Firefox, Safari, Chrome])
					if(x[i].className.indexOf("video")==-1) // bypass if video
					{				
						try{
							var y = (x[i].contentWindow || x[i].contentDocument);
							if (y.window) y = y.document;
							var svg_elements=y.getElementsByTagName('svg');
							// set internal svg dimensions
								svg_elements[0].setAttributeNS(null, "width", x[i].width);
								svg_elements[0].setAttributeNS(null, "height", x[i].height);	
							}
						catch(err){
							//console.log("Failed to restore internal SVG dimensions. Page possibly called from local filesystem.");
						};
					};
			// scale
				if(x[i].width>textWidth)
				{
					scale_factor=textWidth/parseInt(x[i].width,10);
					x[i].height=Math.floor(scale_factor*parseInt(x[i].height,10));	
					x[i].width=Math.floor(scale_factor*parseInt(x[i].width,10));	
					// set new internal svg dimensions (fixes iframe scrollbar problem when page is zoomed [Firefox, Safari, Chrome])
						if(x[i].className.indexOf("video")==-1) // bypass if video
						{						
							try{
								var y = (x[i].contentWindow || x[i].contentDocument);
								if (y.window) y = y.document;
								var svg_elements=y.getElementsByTagName('svg');
								// set internal svg dimensions
									svg_elements[0].setAttributeNS(null, "width", x[i].width);
									svg_elements[0].setAttributeNS(null, "height", x[i].height);
								}
							catch(err){
								//console.log("Failed to adjust internal SVG dimensions. Page possibly called from local filesystem.");
							};
						};
				};
		};
		// math
/*  		   MathJax.Hub.Queue(function () {
				var math = document.getElementsByClassName("scalable_Math");
				var i;
				var mathDivWidth =0.7*textWidth;
				for (i = 0; i < math.length; i++) {
					var math_display_style=math[i].style.display;
					math[i].style.display = "inline"; 
					var mathWidth = math[i].offsetWidth;				
					math[i].style.display = math_display_style;					
					if (mathWidth > mathDivWidth) {
						math[i].style.fontSize = Math.floor(mathDivWidth/mathWidth * 100)+"%"
						}
						else
						{
							math[i].style.fontSize ='100%';
						}
					MathJax.Hub.Queue(["Rerender",MathJax.Hub,math[i]]);
					};
				}); */
	}
		
function toggleSolutionProof(div_id) {
	/* exit if the reading system does not support scripting */
		if (!setting['scriptEnabled']) { return; }
	solutionProofDiv=document.getElementById(div_id);
	solutionProofButtonDiv=document.getElementById(div_id+'_button');
	button_status=solutionProofButtonDiv.innerHTML;
	if(button_status=='Εμφάνιση'){
		solutionProofButtonDiv.innerHTML='Απόκρυψη';
		solutionProofDiv.style.display='block';		
	}
	else
	{
		solutionProofButtonDiv.innerHTML='Εμφάνιση';
		solutionProofDiv.style.display='none';
	};
}
