// Created by John Liaperdos - 29 April 2015
// Modified: August 27, 2015

var original_widths = new Array();
var original_heights = new Array();	

window.addEventListener('resize', function(event){
  fixLayout();
});

function storeDimensions(){
	// store original dimensions
		var x = document.getElementsByTagName("svg");
		var i;
		for (i = 0; i < x.length; i++) {		
				original_heights[i]=x[i].height.baseVal.value;	
				original_widths[i]=x[i].width.baseVal.value;
		};
}	

function fixLayout(){
	restoreOriginalDimensions();
	autoScaleInteractive();
}

function restoreOriginalDimensions(){
	var x = document.getElementsByTagName("svg");
	var i;	
	for (i = 0; i < x.length; i++) {	
			// since fonts are scaled, we also apply the corresponding scale factor
				x[i].height.baseVal.value=parseInt(font_size_contribution_to_image_scale_factor*original_heights[i],10);	
				x[i].width.baseVal.value=parseInt(font_size_contribution_to_image_scale_factor*original_widths[i],10);			
				x[i].setAttribute("width", x[i].width.baseVal.value);
				x[i].setAttribute("height", x[i].height.baseVal.value);				
	};	
}

function autoScaleInteractive() 
{
	var x = document.getElementsByTagName("svg");
	var i;
	for (i = 0; i < x.length; i++) {
		textWidth=x[i].parentNode.offsetWidth;
		if(x[i].width.baseVal.value>textWidth)
		{
			scale_factor=textWidth/parseInt(x[i].width.baseVal.value,10);
			x[i].height.baseVal.value=Math.floor(scale_factor*parseInt(x[i].height.baseVal.value,10));	
			x[i].width.baseVal.value=Math.floor(scale_factor*parseInt(x[i].width.baseVal.value,10));
			x[i].setAttribute("width", x[i].width.baseVal.value);
			x[i].setAttribute("height", x[i].height.baseVal.value);					
		};
	};
}
