// Created by John Liaperdos - August 08, 2015
// Modified: August 27, 2015

// preload images
	var fonts_icon_Image=new Image();
    fonts_icon_Image.src="../images/misc/fonts_icon.png";
	var fonts_larger_button_Image=new Image();
    fonts_larger_button_Image.src="../images/misc/fonts_larger_button.png";
	var fonts_normal_button_Image=new Image();
    fonts_normal_button_Image.src="../images/misc/fonts_normal_button.png";
	var fonts_smaller_button_Image=new Image();
    fonts_smaller_button_Image.src="../images/misc/fonts_smaller_button.png";	
	

var default_font_size=16; // in px
var current_font_size=16; // in px
var min_font_size=12; // in px
var max_font_size=30; // in px
var font_size_contribution_to_image_scale_factor=1; // when fonts are scaled, images should scale accordingly

function setFontSize(){
	current_font_size=parseInt(getCookie('intro_to_electronics_font_size'),10);
	try{
		if(current_font_size=='' || isNaN(current_font_size))
		{
			current_font_size=default_font_size;
		};
	}
	catch(err)
	{
		current_font_size=default_font_size;
	};
	document.body.style.fontSize=current_font_size+'px'
	font_size_contribution_to_image_scale_factor=current_font_size/default_font_size;
}

function loadFontMenu(){
	// create div
		// font icon
		var fontIconElement = document.createElement("img");
		fontIconElement.src=fonts_icon_Image.src;
		fontIconElement.alt="";
		fontIconElement.style.width="20px";
		fontIconElement.style.height="20px";
		fontIconElement.style.verticalAlign="middle";
		fontIconElement.style.marginTop="3px";
		
		// scale up button
		var scaleUpFontElement = document.createElement("img");
		scaleUpFontElement.src=fonts_larger_button_Image.src;
		scaleUpFontElement.alt="";
		scaleUpFontElement.style.width="20px";
		scaleUpFontElement.style.height="20px";
		scaleUpFontElement.title="μεγαλύτερο μέγεθος γραμματοσειράς";
		scaleUpFontElement.className="toolbutton";
		scaleUpFontElement.style.marginTop="3px";
		scaleUpFontElement.onclick=function(){increaseFontSize();};
		
		// reset font size button
		var resetFontElement = document.createElement("img");
		resetFontElement.src=fonts_normal_button_Image.src;
		resetFontElement.alt="";
		resetFontElement.style.width="20px";
		resetFontElement.style.height="20px";
		resetFontElement.title="προκαθορισμένο μέγεθος γραμματοσειράς";
		resetFontElement.className="toolbutton";
		resetFontElement.style.marginTop="3px";
		resetFontElement.onclick=function(){resetFontSize();};

		// scale down button
		var scaleDownFontElement = document.createElement("img");
		scaleDownFontElement.src=fonts_smaller_button_Image.src;
		scaleDownFontElement.alt="";
		scaleDownFontElement.style.width="20px";
		scaleDownFontElement.style.height="20px";
		scaleDownFontElement.title="μικρότερο μέγεθος γραμματοσειράς";
		scaleDownFontElement.className="toolbutton";
		scaleDownFontElement.style.marginTop="3px";
		scaleDownFontElement.onclick=function(){decreaseFontSize();};			
		
		// assemble container div
		var fontContainerElement = document.createElement("div");
		fontContainerElement.id="fontAdjustDiv";
		fontContainerElement.className="fonts_scale_div";
		// display at bottom-right corner if book logo is not included in page
			book_div_element=document.getElementsByClassName("book_logo");
			if(book_div_element.length==0)
			{
				fontContainerElement.style.bottom=0;
			}
	
		// append content to container div
		fontContainerElement.appendChild(fontIconElement);
		fontContainerElement.appendChild(scaleDownFontElement);			
		fontContainerElement.appendChild(resetFontElement);	
		fontContainerElement.appendChild(scaleUpFontElement);

		// add container to document
		document.body.appendChild(fontContainerElement);
		
		// make container visible
		document.getElementById('fontAdjustDiv').style.display='inline-block';		
}

var oldTotalPageHeight;
var oldPagePosition;
function increaseFontSize(){
	oldTotalPageHeight=calculateTotalPageHeight();
	oldPagePosition=getCurrentPosition();
	next_font_size=current_font_size+1;
	if(next_font_size<=max_font_size)
	{
		current_font_size=current_font_size+1;
		document.body.style.fontSize=current_font_size+'px'
		setCookie('intro_to_electronics_font_size', current_font_size, 1000);
		// resize SVG images and videos
			font_size_contribution_to_image_scale_factor=current_font_size/default_font_size;
			try{autoScaleSVGs();}catch(err){}; // not all pages have images	
		// resize images in interactive elements
			try{autoScaleInteractive();}catch(err){}; 
		// resize PNG images
			scalePNGimages();	
		// keep page in focus
			keepPageInFocus();			
	};
}

function decreaseFontSize(){
	oldTotalPageHeight=calculateTotalPageHeight();
	oldPagePosition=getCurrentPosition();
	next_font_size=current_font_size-1;
	if(next_font_size<min_font_size){return};
	current_font_size=current_font_size-1;
	document.body.style.fontSize=current_font_size+'px'
	setCookie('intro_to_electronics_font_size', current_font_size, 1000);
	font_size_contribution_to_image_scale_factor=current_font_size/default_font_size;
	// resize SVG images and videos
		font_size_contribution_to_image_scale_factor=current_font_size/default_font_size;
		try{autoScaleSVGs();}catch(err){}; // not all pages have images	
	// resize PNG images
		scalePNGimages();
	// keep page in focus
		keepPageInFocus();
}

function resetFontSize(){
	oldTotalPageHeight=calculateTotalPageHeight();
	oldPagePosition=getCurrentPosition();
	current_font_size=default_font_size;
	document.body.style.fontSize=current_font_size+'px'
	setCookie('intro_to_electronics_font_size', current_font_size, 1000);
	// resize SVG images and videos
		font_size_contribution_to_image_scale_factor=1;
		try{autoScaleSVGs();}catch(err){}; // not all pages have images
	// resize PNG images
		scalePNGimages();
	// keep page in focus
		keepPageInFocus();
}

function forceFontSize(font_size){
	document.body.style.fontSize=font_size+'px'
}

var pngImageParentClassesToExclude=['kallipos_logo','book_logo','fonts_scale_div','pages_div','page_navigation_div','userConfirmation','floatdiv_vertical','floatdiv_horizontal','floating_menu_links','cookies_notification','footnote','searchResultsBrowser','noScalePNGs','deleteBookmarkConfirmationClass']; // classes of DIVs in which png images should not be scaled (i.e., the menu div)
var pngOriginalWidths=[];
var pngOriginalHeights=[];
var pngElementsArray=[];

function checkExcludedClass(pngImageElement){
	var class_match=false;
	for(var i=0;i<pngImageParentClassesToExclude.length;i++)
	{
		if(pngImageElement.parentNode.className.search(pngImageParentClassesToExclude[i])!=-1)
		{ 
			class_match=true;
			break;
		}			
	};
	return class_match;
}

function initializeAutoScalePNGs(){
	pngOriginalWidths=[];
	pngOriginalHeights=[];
	var pngElementsArrayTmp=document.getElementsByTagName('img');
	for(i=0;i<pngElementsArrayTmp.length;i++)
	{
		if(!checkExcludedClass(pngElementsArrayTmp[i]))
		{
			pngElementsArray.push(pngElementsArrayTmp[i]);
		};	
	};		
	for(i=0;i<pngElementsArray.length;i++)
	{
		if(!checkExcludedClass(pngElementsArray[i]))
		{
			pngOriginalWidths[i]=pngElementsArray[i].width; 
			if(typeof(pngElementsArray[i].height) === 'undefined')  
			{
				pngOriginalHeights[i]=-1;
			}
			else
			{
				pngOriginalHeights[i]=pngElementsArray[i].height;	
			}					
		}
	}
	scalePNGimages();
}

function scalePNGimages(){	
	for(i=0;i<pngElementsArray.length;i++)
	{
		if(pngImageParentClassesToExclude.indexOf(pngElementsArray[i].parentNode.className)==-1)
		{
			pngElementsArray[i].width=parseInt(font_size_contribution_to_image_scale_factor*pngOriginalWidths[i],10);
			if(pngOriginalHeights[i]>0)
			{
				pngElementsArray[i].height=parseInt(font_size_contribution_to_image_scale_factor*pngOriginalHeights[i],10);
			}
		}
	};	
}

function calculateTotalPageHeight(){
	var body = document.body,
		html = document.documentElement;
	var height = Math.max( body.scrollHeight, body.offsetHeight, 
						   html.clientHeight, html.scrollHeight, html.offsetHeight );
	return height;
}

function getCurrentPosition(){
    if(typeof pageYOffset!= 'undefined'){
        return pageYOffset;
    }
    else{
        var B= document.body; 
        var D= document.documentElement; 
        D= (D.clientHeight)? D: B;
        return D.scrollTop;
    }
}

function keepPageInFocus(){
	newTotalPageHeight=calculateTotalPageHeight();
	new_position=Math.ceil(oldPagePosition*newTotalPageHeight/oldTotalPageHeight); 
	window.scrollTo(0, new_position);
}





