// Created by John Liaperdos - August 23, 2015
// Modified: September 9, 2015

// settings are stored in a single cookie, e.g. "100110010", with each bit corresponding to a setting 

var ajaxErrorOccurred=false;

function manageSettings(){
	var cookie=getCookie("intro_to_electronics_settings");
	$(".settings_selector").prop('checked',false);
	$('#settings_select-8').prop('disabled',false);
	if(cookie!='' && cookie!='null' && cookie!==null)
	{
		var settings_cookie=cookieToSettings();
		for(var i=0;i<9;i++)
		{
			if(settings_cookie[i]==1)
			{
				$('#settings_select-'+i).prop('checked',true);
			};			
		};
	}
	else
	{
		$(".settings_selector").prop('checked',true);
		$("#settings_select-8").prop('checked',false);		
	};
	var cookie=getCookie("intro_to_electronics_google_script_URL");
	if(cookie!='' && cookie!='null' && cookie!==null)
	{
		$("#google_script_URL_textbox").val(cookie);
	};
}

function applySettingsChanges(){
	if($("#settings_select-8").prop('checked')==true &&	($("#google_script_URL_textbox").val().length<35 || $("#google_script_URL_textbox").val().indexOf("https://script.google.com/macros")==-1))
	{
		$("#settings_message_area").html('Ο σύνδεσμος (URL) προς το Google App δεν είναι έγκυρος. Οι ρυθμίσεις δεν ενημερώθηκαν.');
		return;
	};
	if($("#settings_select-8").prop('checked')==true && cookieToSettings()[8]==0) //copy LocalStorage data to Google Drive
	{
		$("#settings_message_area").html('Μεταφορά δεδομένων στο Google Drive ...');
		var googleScriptURL=$("#google_script_URL_textbox").val();
		var bookmarks=localStorage.getItem('intro_to_electronics_bookmarks');
		if(bookmarks===null || bookmarks=='null'){bookmarks=''};
		ajaxErrorOccurred=false;
		// copy bookmarks (bookmarks saved in spreadsheet cell "A1")
			$.post(googleScriptURL, {cellID: "A1", cellContent: bookmarks, mode:"setValue"});
		// copy user notes (user notes saved [per chapter] in spreadsheet cells "B1-I1")
			for(var i=1;i<9;i++)
			{
				var user_note_data=localStorage.getItem('intro_to_electronics_user_notes_chapter_0'+i);
				if(user_note_data===null || user_note_data=='null'){user_note_data=''};
				$.post(googleScriptURL, {cellID: String.fromCharCode(65 + i)+"1", cellContent: user_note_data, mode:"setValue"});				
			};
		// copy highlights (user notes saved [per chapter] in spreadsheet cells "J1-Q1")
			for(var j=1;j<9;j++)
			{
				var user_highlight_data=localStorage.getItem('intro_to_electronics_stored_chapter_content_'+j);
				if(user_highlight_data===null || user_highlight_data=='null'){user_highlight_data=''};
				$.post(googleScriptURL, {cellID: String.fromCharCode(73 + j)+"1", cellContent: user_highlight_data, mode:"setValue"});				
			};			
	}
	else
	{
		if($("#settings_select-8").prop('checked')==false && cookieToSettings()[8]==1) //copy Google Drive data to LocalStorage
		{
			ajaxErrorOccurred=false;
			// fetch bookmarks
				$("#settings_message_area").html('Οι σελιδοδείκτες σας μεταφέρονται από το Google Drive ...');
				var googleScriptURL=$("#google_script_URL_textbox").val();
				$.post(googleScriptURL, {mode: "getValue", cellID: "A1"}, 
					function(data, status){
						if(status!="success") 
						{
							$("#settings_message_area").html('Η μεταφορά δεδομένων απέτυχε. Ελέγξτε την εγκυρότητα των ρυθμίσεών σας.');
						};					
						if(data===null || data=='null'){data=""};
						localStorage.setItem('intro_to_electronics_bookmarks',data);					
					}						
				);
			$("#settings_message_area").html('Μεταφορά δεδομένων από το Google Drive ...');	
			// fetch user notes
				function fetchUserNotes(callback) {
					var requests = [];
					for (var i=1; i<9; i++) 
					{
						requests.push($.post(googleScriptURL, {mode: "getValue", cellID: String.fromCharCode(65 + i)+"1"}));
					}
					$.when.apply($, requests).then(function () {
						var array = $.map(arguments, function (arg) {
							return arg[0];
						});
						callback(array);
					})
				};

				fetchUserNotes(function (array) {
					for (var i=1; i<9; i++) 
					{
						var data=array[i-1];
						if(data===null || data=='null'){data=""};
						localStorage.setItem('intro_to_electronics_user_notes_chapter_0'+i,data);	
					};
				});
			// fetch user highlights
				function fetchUserHighlights(callback) {
					var requests = [];
					for (var i=1; i<9; i++) 
					{
						requests.push($.post(googleScriptURL, {mode: "getValue", cellID: String.fromCharCode(73 + i)+"1"}));
					}
					$.when.apply($, requests).then(function () {
						var array = $.map(arguments, function (arg) {
							return arg[0];
						});
						callback(array);
					})
				};

				fetchUserHighlights(function (array) {
					for (var i=1; i<9; i++) 
					{
						var data=array[i-1];
						if(data===null || data=='null'){data=""};
						localStorage.setItem('intro_to_electronics_stored_chapter_content_'+i,data);	
					};
					$("#settings_message_area").html('Οι ρυθμίσεις ενημερώθηκαν');
				});								
		}
		else
		{
			$("#settings_message_area").html('Οι ρυθμίσεις ενημερώθηκαν');
		};			
	}
	settingsToCookie();
	setCookie("intro_to_electronics_google_script_URL", $("#google_script_URL_textbox").val(), 4000);
}

function showSettingsMessage(message_id){
	if(message_id==8)
	{
		if($('#settings_select-'+message_id).prop('checked')==true)
		{
			$("#settings_message_area").html(settingsMessages[message_id]);
		}
		else
		{
			$("#settings_message_area").html('<i>Περιοχή μηνυμάτων</i>');
		};			
	}
	else
	{
		if($('#settings_select-'+message_id).prop('checked')==false)
		{
			$("#settings_message_area").html(settingsMessages[message_id]);
		}
		else
		{
			$("#settings_message_area").html('<i>Περιοχή μηνυμάτων</i>');
		};			
	};
}

function selectAllSettings(){
	$(".settings_selector").prop('checked',true);
}

function deselectAllSettings(){
	$(".settings_selector").prop('checked',false);
}

function cookieToSettings(){
	var settingsArray=[];
	var cookie=getCookie("intro_to_electronics_settings");
	for(var i=0;i<9;i++)
	{
		settingsArray[i]=cookie.substring(i,i+1);
	};
	return settingsArray;
}

function settingsToCookie(){
	var result_string='';
	for(var i=0;i<9;i++)
	{
		if($('#settings_select-'+i).prop('checked')==true)
		{
			result_string+="1";
		}
		else
		{
			result_string+="0";
		};	
	};
	setCookie("intro_to_electronics_settings", result_string, 4000);
}

var settingsMessages=[];
settingsMessages[0]='Με την απενεργοποίηση της επισήμανσης κειμένου, δεν θα εμφανίζονται οι επισημάνσεις που έχετε προσθέσει, ούτε θα μπορείτε να προσθέσετε νέες. Με την εκ νέου ενεργοποίηση οι αποθηκευμένες επισημάνσεις σας αποκαθίστανται.';
settingsMessages[1]='Με την απενεργοποίηση των προσωπικών σημειώσεων θα μπορείτε να βλέπετε, να αποθηκεύετε και να διαγράφετε τις σημειώσεις σας, όχι όμως και να προσθέτετε νέες.';
settingsMessages[2]='Με την απενεργοποίηση των σελιδοδεικτών θα μπορείτε να χρησιμοποιείτε και να διαγράφετε τους σελιδοδείκτες σας. Δεν θα μπορείτε να προσθέσετε νέους, ούτε θα εμφανίζονται τα εικονίδια των σελιδοδεικτών εντός των κεφαλαίων.';
settingsMessages[3]='Δεν θα έχετε πρόσβαση στα εργαλεία πλοήγησης σε επίπεδο σελίδας.';
settingsMessages[4]='Ο πίνακας περιεχομένων ανά κεφάλαιο θα απενεργοποιηθεί, αλλά θα μπορείτε να χρησιμοποιείτε τον πίνακα περιεχομένων του συγγράμματος.';
settingsMessages[5]='Η δυνατότητα αναζήτησης όρων στα κείμενα των κεφαλαίων θα απενεργοποιηθεί.';
settingsMessages[6]='Θα απενεργοποιηθεί η δυνατότητα μεγέθυνσης των σχημάτων τα οποία περιλαμβάνονται στα κεφάλαια, όπως και η πλοήγηση στα σχήματα μέσω αναδυόμενου παραθύρου.';
settingsMessages[7]='Όταν χρησιμοποιείτε τα πλήκτρα πλοήγησης σε επίπεδο σελίδας η εναλλαγή θα είναι άμεση, χωρίς ολίσθηση (scroll). Η επιλογή έχει ισχύ όταν τα εργαλεία πλοήγησης σε επίπεδο σελίδας είναι ενεργά.';
settingsMessages[8]='Η αποθήκευση των εξατομικευμένων δεδομένων του αναγνώστη (προσωπικές σημειώσεις, σελιδοδείκτες, επισημάνσεις κειμένου) θα αποθηκεύονται μέσω της υπηρεσίας Google Drive, εφόσον η αποθήκευση αυτών των δεδομένων είναι ενεργοποιημένη και εφόσον έχει προηγηθεί σωστή ρύθμιση της επιλογής. Οδηγίες ρύθμισης είναι διαθέσιμες μέσω του πλήκτρου <img src="../images/misc/question_mark.png" style="width:20px; height:20px;" alt=""/> το οποίο εμφανίζεται πιο πάνω. Με την ενεργοποίηση / απενεργοποίηση της επιλογής τα ήδη αποθηκευμένα δεδομένα θα αντιγράφονται από την περιοχή τοπικής αποθήκευσης (Local Storage) του φυλλομετρητή σας στην υπηρεσία Google Drive, και αντίστροφα. Με την επιλογή αποθήκευσης στο Google Drive, η απόκριση ορισμένων λειτουργιών του γραφικού περιβάλλοντος του συγγράμματος ενδέχεται να είναι πιο αργή, ανάλογα και με την ταχύτητα της διαδικτυακής σας σύνδεσης όπως και με τον όγκο της αποθηκευμένης πληροφορίας.';

function checkIfSearchEnabled(){
	if(!checkIfSettingEnabled(5))
	{
		$('#main_div').html('<i>Έχετε απενεργοποιήσει τη δυνατότητα αναζήτησης. Για να την ενεργοποιήσετε εκ νέου, μεταβείτε στη <a href="settings.xhtml"> σελίδα των ρυθμίσεων</a>.</i>');
	};
	$('#main_div').css("display","block");
}

function checkIfSettingEnabled(option_id){
	//check if option is enabled, or default settings apply
	if(option_id==8 && getCookie("intro_to_electronics_settings")=='')
	{
		return false;
	};
	return (cookieToSettings()[option_id]=="1" || (cookieToSettings().indexOf('0')==-1 && cookieToSettings().indexOf('1')==-1));
}


// handle ajax errors (used to handle Safari lack of support for ajax calls to Google Drive)
	$(document).ajaxError(function() {
		ajaxErrorOccurred=true;
		//take action only when called from the "settings" page
			if(window.location.href.indexOf('/settings.xhtml')!=-1)
			{
				//Google Drive Storage is not Supported
					$("#settings_message_area").html('<span style="color:red;">Συνέβη σφάλμα κατά τη μεταφορά των δεδομένων. Ελέγξτε τις ρυθμίσεις σας και τη σύνδεσή σας στο διαδίκτυο και προσπαθήστε ξανά, λαμβάνοντας υπόψη πως ο φυλλομετρητής Safari δεν υποστηρίζει την αποθήκευση δεδομένων στο Google Drive.</span>');
					$("#settings_select-8").prop('checked',false);
					//$('#settings_select-8').prop('disabled',true);
					settingsToCookie();
			};
	});

//display message when all ajax calls have finished
	$(document).ajaxStop(function() {
	//take action only when called from the "settings" page and an error has not already occurred
		if(ajaxErrorOccurred==false && window.location.href.indexOf('/settings.xhtml')!=-1)
		{
			$("#settings_message_area").html('Οι ρυθμίσεις ενημερώθηκαν');
		};
	});
