// Created by John Liaperdos - August 17, 2015
// Modified: September 9, 2015 

var cookieNamesArray=[
	'intro_to_electronics_anchored_page',
	'intro_to_electronics_scroll_window',
	'intro_to_electronics_vertical_scroll',
	'intro_to_electronics_proofs_status',
	'intro_to_electronics_solutions_status',
	'intro_to_electronics_cookies_accepted',
	'intro_to_electronics_float_menu_position',
	'intro_to_electronics_current_logo_index',
	'intro_to_electronics_font_size',
	'intro_to_electronics_font_family',
	'intro_to_electronics_settings',
	'intro_to_electronics_zoomed_figure_dimensions',
	'intro_to_electronics_google_script_URL'
];

var localStorageSingleKeyNamesArray=[
	'intro_to_electronics_bookmarks',
	'intro_to_electronics_show_search_results',
	'intro_to_electronics_search_term'
];

var general_functionality_space=0;
var space_allocated_to_chapters=[];
var space_allocated_to_chapters_uncompressed=[];

var userNotesStorageKeysPrefix='intro_to_electronics_user_notes_chapter_0'; // append chapter number, e.g. 1
var userHighlightsStorageKeysPrefix='intro_to_electronics_stored_chapter_content_'; // append chapter number, e.g. 1

var reportPendingInterval;
var countReportMessageIterations;

function animateReportPendingMessage(){
	countReportMessageIterations++;
	if(countReportMessageIterations==75) //abort after 5 minutes
	{
		clearInterval(reportPendingInterval);
		document.getElementById('storage_summary_report').innerHTML='Η ανάκτηση δεδομένων από το Google Drive απέτυχε. Ελέγξτε τη σύνδεσή σας στο διαδίκτυο και τις ρυθμίσεις σας.';
		return;
	};
	if(countReportMessageIterations%2==0)
	{
		document.getElementById('storage_summary_report').innerHTML='Παραγωγή αναφοράς ...<br/> &#160;';
	}
	else
	{
		document.getElementById('storage_summary_report').innerHTML='Παραγωγή αναφοράς ...<br/> <i>Η παραγωγή της αναφοράς ενδέχεται να διαρκέσει μερικά λεπτά, καθώς πραγματοποιείται ανάκτηση δεδομένων από το Google Drive.</i>';
	};
}

function createStorageReport(){
	if(!checkIfSettingEnabled(8) || getCookie('intro_to_electronics_settings')=='') //data saved in Local Storage
	{
		document.getElementById('storage_summary_report').innerHTML='Παραγωγή αναφοράς ...';
	}
	else //data saved in Google Drive
	{
		document.getElementById('storage_summary_report').innerHTML='Παραγωγή αναφοράς ...<br/> <i>Η παραγωγή της αναφοράς ενδέχεται να διαρκέσει μερικά λεπτά, καθώς πραγματοποιείται ανάκτηση δεδομένων από το Google Drive.</i>';
		countReportMessageIterations=0;
		reportPendingInterval=setInterval(animateReportPendingMessage,4000);
	};
	document.getElementById("refreshStorageReportButton").style.display="none"; 
	document.getElementById("freeSpaceButton").style.display="none"; 		
	general_functionality_space=0;	
	var space_allocated_to_cookies=getCookiesStorageSpace();
	var local_storage_space=getLocalStorageSpace()[0];
	var local_storage_space_uncompressed=getLocalStorageSpace()[1];
	var local_storage_compression_ratio=0;
	if(local_storage_space_uncompressed>0)
	{
		local_storage_compression_ratio=parseInt(100000*local_storage_space/local_storage_space_uncompressed,10)/1000;
	};
	var total_storage_compression_ratio=0;
	if((local_storage_space_uncompressed+space_allocated_to_cookies)>0)
	{
		total_storage_compression_ratio=parseInt(100000*(local_storage_space+space_allocated_to_cookies)/(local_storage_space_uncompressed+space_allocated_to_cookies),10)/1000;
	};
	var report_content='';
	report_content+='Σύνολο χρησιμοποιούμενου τοπικού αποθηκευτικού χώρου (Local Storage + cookies): <b>'+ bytesToString(space_allocated_to_cookies+local_storage_space)+'</b> ';
	if((space_allocated_to_cookies+local_storage_space) && total_storage_compression_ratio<100)
	{
		report_content+='<i>('+bytesToString(space_allocated_to_cookies+local_storage_space_uncompressed)+' - συμπίεση στο '+total_storage_compression_ratio+' %)</i><br/>';
	}
	else
	{
		report_content+='<br/>';
	};
	report_content+='Σε cookies χρησιμοποιούνται: '+ bytesToString(space_allocated_to_cookies);
	report_content+='<br/>';
	report_content+='Σε χώρο τοπικής αποθήκευσης (Local Storage) χρησιμοποιούνται: '+ bytesToString(local_storage_space);
	if((local_storage_space) && local_storage_compression_ratio<100 && local_storage_compression_ratio>0)
	{
		report_content+=' <i>('+bytesToString(local_storage_space_uncompressed)+' - συμπίεση στο '+local_storage_compression_ratio+' %)</i><br/>';
	}
	else
	{
		report_content+='<br/>';
	};	
	report_content+='<hr/>';
	report_content+='Ανάλυση χρήσης χώρου τοπικής αποθήκευσης: <br/>'
	report_content+='<br/>';
	for(var i=0;i<8;i++)
	{
		report_content+='<i style="margin-left:20px;">Κεφάλαιο '+(i+1)+'</i>: <b>'+bytesToString(space_allocated_to_chapters[i])+'</b> ';
		var chapter_space_compression_ratio=0;
		if(space_allocated_to_chapters[i])
		{
			if(space_allocated_to_chapters_uncompressed[i]>0)
			{
				chapter_space_compression_ratio=parseInt(100000*space_allocated_to_chapters[i]/space_allocated_to_chapters_uncompressed[i],10)/1000;
			};
			if (chapter_space_compression_ratio<100 && chapter_space_compression_ratio>0)
			{
				report_content+='<i>('+bytesToString(space_allocated_to_chapters_uncompressed[i])+' - συμπίεση στο '+chapter_space_compression_ratio+' %)</i><br/>';
			}
			else
			{
				report_content+='<br/>';
			};
		}
		else
		{
			report_content+='<br/>';
		};
	}
	report_content+='<br/> Λοιπές λειτουργίες: '+bytesToString(general_functionality_space);
	if(!checkIfSettingEnabled(8) || getCookie('intro_to_electronics_settings')=='') //data saved in Local Storage
	{
		document.getElementById('storage_summary_report').innerHTML=report_content;
		document.getElementById("refreshStorageReportButton").style.display="inline"; 
		document.getElementById("freeSpaceButton").style.display="inline"; 			
	}
	else //data saved in Google Drive
	{
		var google_script_URL=getCookie("intro_to_electronics_google_script_URL");
		$.post(google_script_URL, {mode: "getSize", cellID: ""}, 
			function(data, status){
				report_content+='<hr/>Όγκος δεδομένων στο Google Drive: <b>'+bytesToString(data)+'</b><br/>';
				document.getElementById('storage_summary_report').innerHTML=report_content;
				document.getElementById("refreshStorageReportButton").style.display="inline"; 
				document.getElementById("freeSpaceButton").style.display="inline";
				clearInterval(reportPendingInterval);
			}						
		);	
	};
}

function getCookiesStorageSpace(){
	return byteLength(document.cookie);
}

function getLocalStorageSpace(){
	space_allocated_to_chapters=[0,0,0,0,0,0,0,0];
	space_allocated_to_chapters_uncompressed=[0,0,0,0,0,0,0,0];
	general_functionality_space=0;
	var total_space=0;
	var total_space_uncompressed=0;
	for(var i=0;i<localStorageSingleKeyNamesArray.length;i++)
	{
		if(localStorage.getItem(localStorageSingleKeyNamesArray[i]))
		{
			total_space+=byteLength(localStorage.getItem(localStorageSingleKeyNamesArray[i]));
			total_space_uncompressed+=byteLength(localStorageGetDeCompress(localStorageSingleKeyNamesArray[i]));
		};		
	};
	general_functionality_space+=total_space;
	for(var i=1;i<9;i++)
	{
		if(localStorage.getItem(userNotesStorageKeysPrefix+i))
		{
			var individual_space=byteLength(localStorage.getItem(userNotesStorageKeysPrefix+i));
			var individual_space_uncompressed=byteLength(localStorageGetDeCompress(userNotesStorageKeysPrefix+i));
			total_space+=individual_space;
			total_space_uncompressed+=individual_space_uncompressed;
			space_allocated_to_chapters[i-1]+=individual_space;
			space_allocated_to_chapters_uncompressed[i-1]+=individual_space_uncompressed;
		};
		if(localStorage.getItem(userHighlightsStorageKeysPrefix+i))
		{
			var individual_space=byteLength(localStorage.getItem(userHighlightsStorageKeysPrefix+i)); 
			var individual_space_uncompressed=byteLength(localStorageGetDeCompress(userHighlightsStorageKeysPrefix+i)); 
			total_space+=individual_space;
			total_space_uncompressed+=individual_space_uncompressed;
			space_allocated_to_chapters[i-1]+=individual_space;
			space_allocated_to_chapters_uncompressed[i-1]+=individual_space_uncompressed;
		};					
	}
	return [total_space, total_space_uncompressed];
}

function confirmClearStorageSpace(){
	// show confirmation message
		document.getElementById("emptyStorageConfirmation").style.display="block";
}

function abortClearStorageSpace(){
	// hide confirmation message
		document.getElementById("emptyStorageConfirmation").style.display="none";	
}

var iteration_number_cookies;
var iteration_number_local_storage_single;
var iteration_number_local_storage_multiple;
var iteration_number_local_storage_multiple_second;
var timeout_queue_number=0;
var timeout_delay=100;

function clearStorageSpace(){
	iteration_number_cookies=0;
	iteration_number_local_storage_single=0;
	iteration_number_local_storage_multiple=0;
	iteration_number_local_storage_multiple_second=0;	
	$('#refreshStorageReportButton').prop("disabled",true);
	$('#freeSpaceButton').prop("disabled",true);
	document.getElementById("clearStorageProgress").style.display="block";
	document.getElementById("clearStorageProgress").innerHTML="Γίνεται εκκαθάριση του αποθηκευτικού χώρου ...";
	// hide confirmation message
		document.getElementById("emptyStorageConfirmation").style.display="none";
	// empty cookies
		for(var i=0;i<cookieNamesArray.length;i++)
		{
			setTimeout(function(){
				deleteCookieItem();
				},timeout_queue_number*timeout_delay);
			timeout_queue_number+=1;
		};
	if(!checkIfSettingEnabled(8) || getCookie('intro_to_electronics_settings')=='') //data saved in Local Storage
	{
		// clear LocalStorage
			iteration_number_local_storage_single=0;
			for(var i=0;i<localStorageSingleKeyNamesArray.length;i++)
			{
				setTimeout(function(){deleteSingleLocalStorageItem();},timeout_queue_number*timeout_delay);
				timeout_queue_number+=1;
			};
			iteration_number_local_storage_multiple=1;
			for(var i=1;i<9;i++)
			{
				setTimeout(function(){deleteMultipleLocalStorageItem();},timeout_queue_number*timeout_delay);
				timeout_queue_number+=1;
			};
			iteration_number_local_storage_multiple_second=1;
			for(var i=1;i<9;i++)
			{
				setTimeout(function(){deleteMultipleLocalStorageItemSecond();},timeout_queue_number*timeout_delay);
				timeout_queue_number+=1;
			};
		// refresh report
			setTimeout(function(){createStorageReport();},timeout_queue_number*timeout_delay);
			timeout_queue_number+=1;		
		// done
			setTimeout(function(){
				document.getElementById("clearStorageProgress").innerHTML="<b>Η εκκαθάριση του αποθηκευτικού χώρου ολοκληρώθηκε.</b>";	
				$('#refreshStorageReportButton').prop("disabled",false);
				$('#freeSpaceButton').prop("disabled",false);
				}
				,timeout_queue_number*timeout_delay);
			timeout_queue_number+=1;
		// hide progress div
			setTimeout(function(){document.getElementById("clearStorageProgress").style.display="none";},timeout_queue_number*timeout_delay+4000);	
	}
	else //data saved in Google Drive
	{
		var googleScriptURL=getCookie("intro_to_electronics_google_script_URL");
		if(googleScriptURL!='')
		{
			document.getElementById("clearStorageProgress").innerHTML='Εκκαθάριση χώρου στο Google Drive';
			$.post(googleScriptURL, {mode: "clearAll"},
				function(data, status){
					if(status!="success")
					{
						document.getElementById("clearStorageProgress").innerHTML="<b>Η εκκαθάριση του αποθηκευτικού χώρου απέτυχε. Ελέγξτε την ορθότητα των ρυθμίσεών σας.</b>";
						$('#refreshStorageReportButton').prop("disabled",false);
						$('#freeSpaceButton').prop("disabled",false);					
					}
					else
					{
						document.getElementById("clearStorageProgress").innerHTML="<b>Η εκκαθάριση του αποθηκευτικού χώρου ολοκληρώθηκε.</b>";
						setTimeout(function(){
							$('#refreshStorageReportButton').prop("disabled",false);
							$('#freeSpaceButton').prop("disabled",false);
							createStorageReport(); //refresh report
							document.getElementById("clearStorageProgress").style.display="none";
						},4000);
					};
				}
			);				
		}
		else
		{
			document.getElementById("clearStorageProgress").innerHTML="<b>Η εκκαθάριση χώρου στο Google Drive απέτυχε: Δεν βρέθηκε έγκυρος σύνδεσμος στο αντίστοιχο Google App.</b>";
			setTimeout(function(){
				$('#refreshStorageReportButton').prop("disabled",false);
				$('#freeSpaceButton').prop("disabled",false);
				createStorageReport(); //refresh report
				document.getElementById("clearStorageProgress").style.display="none";
			},4000);			
		};	
	};	
}

function deleteCookieItem(){	
	if(cookieNamesArray[iteration_number_cookies]!='intro_to_electronics_google_script_URL')
	{
		document.getElementById("clearStorageProgress").innerHTML="Διαγραφή του cookie: <i>"+cookieNamesArray[iteration_number_cookies]+"</i> ...";
		setCookie(cookieNamesArray[iteration_number_cookies], '', -1);
	};	
	iteration_number_cookies+=1;
}

function deleteSingleLocalStorageItem(){
	document.getElementById("clearStorageProgress").innerHTML="LocalStorage: Διαγραφή του κλειδιού: <i>"+localStorageSingleKeyNamesArray[iteration_number_local_storage_single]+"</i> ...";	
	if(localStorage.getItem(localStorageSingleKeyNamesArray[iteration_number_local_storage_single]))
	{
		localStorage.removeItem(localStorageSingleKeyNamesArray[iteration_number_local_storage_single]);
	};
	iteration_number_local_storage_single+=1;	
}

function deleteMultipleLocalStorageItem(){
	document.getElementById("clearStorageProgress").innerHTML="LocalStorage: Διαγραφή του κλειδιού: <i>"+userNotesStorageKeysPrefix+iteration_number_local_storage_multiple+"</i> ...";
	if(localStorage.getItem(userNotesStorageKeysPrefix+iteration_number_local_storage_multiple))
	{
		localStorage.removeItem(userNotesStorageKeysPrefix+iteration_number_local_storage_multiple);
	};			
	iteration_number_local_storage_multiple+=1;
}

function deleteMultipleLocalStorageItemSecond(){
	document.getElementById("clearStorageProgress").innerHTML="LocalStorage: Διαγραφή του κλειδιού: <i>"+userHighlightsStorageKeysPrefix+iteration_number_local_storage_multiple_second+"</i> ...";
	if(localStorage.getItem(userHighlightsStorageKeysPrefix+iteration_number_local_storage_multiple_second))
	{
		localStorage.removeItem(userHighlightsStorageKeysPrefix+iteration_number_local_storage_multiple_second);
	};				
	iteration_number_local_storage_multiple_second+=1;
}

function byteLength(str) {
	var result=0;
	if(str)
	{
		var m = encodeURIComponent(str).match(/%[89ABab]/g);
		result= str.length + (m ? m.length : 0);		  
	};
	return result;
}

function bytesToString(bytes){
	var base=1000; // 1024
	var unitsArray=['TB','GB','MB','kB','B'];
	var i;
    for (i=0; i<5; i++) 
	{
		if(bytes>=Math.pow(base,4-i))
		{
			result=Math.round(100*(bytes/Math.pow(base,4-i)))/100;
			break;
		}
		else
		{
			result=bytes;
		};
	};
	if(i==5){i=4};
	return result+' '+unitsArray[i];
}



