// Created by John Liaperdos - August 26, 2015
// Modified: August 28, 2015

var SVG_image_Array=[];
var iframe_IDs_Array=[];

function initializeFigureZoom(){
	if(checkIfSettingEnabled(6)) //figure zoom is enabled, or default settings apply
	{
		// wait a bit ...
		setTimeout(initializeFigureZoomActual,3000); 
	};
}

var last_user_selected_zoomed_image_width;
var last_user_selected_zoomed_image_height;

function initializeFigureZoomActual(){

	// preload SVGs	
		var chapterNumber=document.getElementsByClassName("chapter_number")[0].innerHTML;
		var iframes=document.getElementsByTagName("iframe");
		for(var i=0;i<iframes.length;i++)
		{
			if(iframes[i].className.indexOf('book_figure')!=-1)
			{
				var tmp=new Image();
				tmp.src='../images/figures/chapter_0'+chapterNumber+'/fig_'+iframes[i].id.substr(7)+'.svg';
				SVG_image_Array.push(tmp);
				iframe_IDs_Array.push(iframes[i].id);
			};
		};

	// set SVG figure cursor and onclick behavior
		$("iframe").each( 
			function(){
				if($(this).hasClass('book_figure'))
				{
					var thisVar=$(this);
					thisVar.contents().find('svg').css('cursor','pointer');
					thisVar.contents().find('svg').on('click',
						function(){
							zoomFigure(thisVar.attr("id"));
						}
					)
				};
			}
		);
	
	// append zoomed SVG container
		$('body').append('<div id="zoomed_figure_outer_container" style="position:fixed; padding:20px; top:0px; width:300px; height:200px; background:rgb(240,255,255); border-style:solid; visibility:hidden; z-index:250; -webkit-box-shadow: 0 0 3px 1px rgba(0, 0, 0, .5); -moz-box-shadow: 0 0 7px 12px rgba(0, 0, 0, .5); box-shadow: 0 0 7px 12px rgba(0, 0, 0, .5);"><div id="zoomed_figure_inner_container" style="width:100%; height:100%;" ></div></div>');

	// append 'close zoomed SVG container' button		
		$('body').append('<div id="hideZoomedFigureDiv" style="position:fixed; z-index:260; top:0; width:600px; height:32px; background:#FFCCE0; padding:0px; border-style:solid; border-color:#FF66A3; font-size:12px; font-family:ClearSans; left:2px; overflow:hidden"><img id="hideZoomedFigureButton" src="../images/misc/close_button.png" alt="" title="Απόκρυψη Σχήματος" class="toolbutton" style="width:30px; height:30px; margin-right:5px; vertical-align:middle;" /><img id="previousZoomedFigureButton" src="../images/misc/previous_figure_button.png" alt="" title="Προηγούμενο Σχήμα" class="toolbutton" style="width:25px; height:25px; margin-right:1px; vertical-align:middle;" /><img id="nextZoomedFigureButton" src="../images/misc/next_figure_button.png" alt="" title="Επόμενο Σχήμα" class="toolbutton" style="width:25px; height:25px; margin-right:10px; vertical-align:middle;" /><span id="zoomedFigureTitle" overflow="hidden" style="width:500px"></span></div>')
		
	// make SVG container draggable
		$("#zoomed_figure_outer_container").draggable({
			containment: "window",
			cursor: "move",
			scroll: false,
			zIndex: 250
			});	
			
	// make SVG container resizable
		$("#zoomed_figure_outer_container").resizable({
			aspectRatio: true,
			containment: "document",
			minHeight: 200,
			minWidth: 200,
			maxWidth: $(window).width()-150,
			maxHeight: $(window).height()-180,
			start: function(event, ui) {
				$('iframe').css('pointer-events','none');
				 },
			stop: function(event, ui) {
				$('iframe').css('pointer-events','auto');
				last_user_selected_zoomed_image_width=$("#zoomed_figure_outer_container").width();
				last_user_selected_zoomed_image_height=$("#zoomed_figure_outer_container").height();				
			  }			
			});

	// define 'close zoomed SVG container' button onclick functionality		
		$('#hideZoomedFigureButton').on('click',
			function(){
				$("#zoomed_figure_outer_container").css('visibility','hidden');
				$('#hideZoomedFigureDiv').css('visibility','hidden');
			}
		);
		
	// define 'previous' button onclick functionality		
		$('#previousZoomedFigureButton').on('click',
			function(){
				//get previous figure id
					var current_figure_index=iframe_IDs_Array.indexOf(current_zoomed_figure_Iframe_ID);
					if(current_figure_index==0){return};
					var previous_figure_index=current_figure_index-1;					
					zoomFigure(iframe_IDs_Array[previous_figure_index]);
			}
		);
		
	// define 'next' button onclick functionality		
		$('#nextZoomedFigureButton').on('click',
			function(){
				//get next figure id
					var current_figure_index=iframe_IDs_Array.indexOf(current_zoomed_figure_Iframe_ID);
					if(current_figure_index==iframe_IDs_Array.length-1){return};
					var next_figure_index=current_figure_index+1;					
					zoomFigure(iframe_IDs_Array[next_figure_index]);
			}
		);
		
	// hide SVG container
		$('#hideZoomedFigureDiv').css('visibility','hidden');
		
}

var current_zoomed_figure_Iframe_ID;

function zoomFigure(figure_id){
	// find figure number and title
		try{
			var parentDiv=$('#'+figure_id).parent();
			var captionParagraph=parentDiv.children()[1];
			var numberSpan=captionParagraph.children[0];
			var titleSpan=captionParagraph.children[1];
			var figureNumber=numberSpan.textContent.trim();
			var figureTitle=titleSpan.textContent.trim();
			var figureCaption='<b><a class="fancyLink" href="#'+figure_id+'" title="Μετάβαση στο '+figureNumber+'" >'+figureNumber+'</a></b>: '+figureTitle;
		}
		catch(err) //figure with no caption
		{
			figureCaption='<i>(το σχήμα δεν διαθέτει τίτλο)</i>';
		};	
	// set figure number and title
		$("#zoomedFigureTitle").html(figureCaption);
		// trim title, if necessary
			if($("#zoomedFigureTitle").width()>500)
			{
				while($("#zoomedFigureTitle").width()>500)
				{
					figureCaption=figureCaption.substr(0,figureCaption.length-1);
					$("#zoomedFigureTitle").html(figureCaption);
				};
				$("#zoomedFigureTitle").html(figureCaption.substr(0,figureCaption.length-4)+' ...');
			};
	// store current figure Iframe ID
		current_zoomed_figure_Iframe_ID=figure_id;
	// load and show figure
		var chapterNumber=document.getElementsByClassName("chapter_number")[0].innerHTML;
		var svg_src=SVG_image_Array[iframe_IDs_Array.indexOf(figure_id)].src;
		var svg_width=parseInt($("#"+figure_id).css("width"),10);
		var svg_height=parseInt($("#"+figure_id).css("height"),10);
		var screen_width=$(window).width()-150;
		var screen_height=$(window).height()-180;
		if(last_user_selected_zoomed_image_width)
		{
			screen_width=last_user_selected_zoomed_image_width;
			screen_height=last_user_selected_zoomed_image_height;
		}
		else
		{
			//get user preferences from cookie, if exist
				var user_figure_zoom_prefs=getCookie('intro_to_electronics_zoomed_figure_dimensions');
				if(user_figure_zoom_prefs!=''  && user_figure_zoom_prefs!='null' && user_figure_zoom_prefs!==null)
				{
					//preferences stored as "width-height"
					var user_figure_zoom_prefs_Array=user_figure_zoom_prefs.split("-");
					last_user_selected_zoomed_image_width=user_figure_zoom_prefs_Array[0];
					last_user_selected_zoomed_image_height=user_figure_zoom_prefs_Array[1];
					screen_width=last_user_selected_zoomed_image_width;
					screen_height=last_user_selected_zoomed_image_height;					
				};
		};
		var horizontal_ratio=screen_width/svg_width;
		var vertical_ratio=screen_height/svg_height;
		var min_ratio=Math.min(horizontal_ratio,vertical_ratio);
		var container_width=svg_width*min_ratio;
		var container_height=svg_height*min_ratio;
		$("#zoomed_figure_outer_container").css("top","35px");
		$("#zoomed_figure_outer_container").css("left","0px");
		$("#zoomed_figure_outer_container").css("width",container_width);
		$("#zoomed_figure_outer_container").css("height",container_height);
		$("#zoomed_figure_inner_container").css("background","url("+svg_src+")");
		$("#zoomed_figure_inner_container").css("background-repeat","no-repeat");
		$("#zoomed_figure_inner_container").css("background-size","contain");
		$("#zoomed_figure_inner_container").css("background-position","center");
		$("#zoomed_figure_outer_container").resizable( "option", "aspectRatio", container_width/container_height );
		$("#zoomed_figure_outer_container").css("visibility","visible");
		$('#hideZoomedFigureDiv').css('visibility','visible');
}

function padFigureNumber(input_string){
	input_string=input_string.toString();
	while(input_string.length<3)
	{
		input_string='0'+input_string;
	};
	return input_string;
}

//save zoomed figure dimensions to a cookie
$( window ).unload(function() {
	if(last_user_selected_zoomed_image_width)
	{	
		setCookie('intro_to_electronics_zoomed_figure_dimensions', last_user_selected_zoomed_image_width+'-'+last_user_selected_zoomed_image_height, 365);
	};
});	
